'
#Include "winFBgui.bi"

'---------------- Dim Cntrols --------------------
Dim Shared As FForm form1
Dim Shared As FButton btnExit,btnCopy
Dim Shared As FCheckBox checkRGB,CheckHex
Dim Shared As FEdit edRot,edBlau,edGruen
Dim Shared As FPanel paColor,paLabelR,paLabelG,paLabelB
Dim Shared As FTrackBar trRot,trBlau,trGruen
Dim Shared As FGroupBox group1

'-------------- Event - Sub -----------------------
#Include "ColorPickUtil.bi"

'------------ Create Control ----------------------
form1.Create("ColorPick",100,100,500,250)
form1.Color = &HDDDDDD
form1.Border= 2

paColor.Create(form1.Handle,2,2,100,110) ' Panel fr Farbe darstellen
paColor.Border = 1
paColor.Color = &H0

trRot.Create(form1.Handle,110,2,370,30)	' Trackbar
trRot.Range(0,255)								' Wertebereich
trRot.TumpColor =bgr(255,0,0) 				' Farbe Knopf
trRot.RilColor  =bgr(255,0,0) 				' Farbe der Rille
trRot.Orientation=0								' Horizontal
trRot.Tick = FALSE								' keine Tick anzeigen
trRot.onChange=@trRot_Change					' Eventsub

trGruen.Create(form1.Handle,110,42,370,30)
trGruen.Range(0,255)
trGruen.TumpColor =bgr(0,255,0) 
trGruen.RilColor	=bgr(0,255,0)
trGruen.Orientation=0
trGruen.Tick = FALSE
trGruen.onChange=@trGruen_Change

trBlau.Create(form1.Handle,110,80,370,30)
trBlau.Range(0,255)
trBlau.TumpColor = bgr(0,0,255)
trBlau.RilColor  = bgr(0,0,255)
trBlau.Orientation=0
trBlau.Tick = FALSE
trBlau.onChange=@trBlau_Change

paLabelR.Create(form1.Handle,2,120,50,22) ' Panel als Label
paLabelR.Caption = "Rot "						' Text
paLabelR.TextAlign = 0							' Linksbndig
paLabelR.TextColor = bgr(255,0,0)			' Textfarbe

paLabelG.Create(form1.Handle,2,150,50,22)
paLabelG.Caption = "Grn"
paLabelG.TextAlign = 0
paLabelG.TextColor =bgr(0,128,0)

paLabelB.Create(form1.Handle,2,180,50,22)
paLabelB.Caption = "Blau"
paLabelB.TextAlign = 0
paLabelB.TextColor =bgr(0,0,255)

edRot.Create(form1.Handle,52,120,50,22)	' Edit
edRot.Number = TRUE								' nur Zahlen erlaubt
edRot.Text = "0"									' Initialtext
edRot.onChange = @edRot_Change				' Eventsub

edGruen.Create(form1.Handle,52,150,50,22)
edGruen.Number= TRUE
edGruen.Text = "0"
edGruen.onChange = @edGruen_Change

edBlau.Create(form1.Handle,52,180,50,22)
edBlau.Number= TRUE
edBlau.Text="0"
edBlau.onChange = @edBlau_Change

group1.Create(form1.Handle,"Kopie zum Clipboard",110,115,240,87)
checkRGB.Create(group1.Handle,"Als RGB",30,20,100,20)	'Checkbox
checkRGB.onClick = @checkRGB_Click
CheckHex.Create(group1.Handle,"Als HEX",30,50,100,20) 'Checkbox
CheckHex.Check = TRUE
CheckHex.onClick = @CheckHex_Click
btnCopy.Create(group1.Handle,"Copy",130,40,90,26)
btnCopy.onClick = @btnCopy_Click
btnExit.Create(form1.Handle,"Exit",380,153,90,26)
btnExit.onClick = @btnExit_Click

form1.Show

ExitProcess(0)
End
