' Diverse Sub / Funk
'--------------------
Sub menu_Copy
	REdit.Copy
End Sub
Sub menu_Paste
	REdit.Paste
End Sub
Sub menu_Del
	REdit.Clear
End Sub
Sub menu_Cut
	REdit.Cut
End Sub

Sub RichEditStart
	
	REdit.ClearAll
	REdit.font.FaceName 	= combo1.GetSelString
	REdit.font.Size 		= Val(combo2.GetSelString)
	REdit.font.Bold		= 0
	REdit.font.Italic		= 0
	REdit.font.Underline	= 0
	REdit.font.StrikeOut	= 0
	REdit.Paraleft			= 1
	REdit.Paracenter		= 0
	REdit.Pararight		= 0
	REdit.GlobalFontStyle ' Globale Font Style setzen
	REdit.Focus
	tbBold.Down 	= 	0
	tbItalic.Down 	= 	0
	tbUnder.Down 	=	0
	tbleft.Down 	=	1
	
End Sub


Sub GetRichEditStyle
	Dim s As String
	
	REdit.GetFontStyle	' Style am Kursor lesen
	REdit.GetParaStyle
	
	' Combobox setzen
	s = REdit.font.FaceName	
   combo1.SelStrItem(s)
   s = Str(REdit.font.Size)
   If Len(s) = 1 Then s = "0"+s 
   combo2.SelStrItem(s)
	
	' Button setzen	
	tbBold.Down 	= 	REdit.font.Bold 
	tbItalic.Down 	= 	REdit.font.Italic
	tbUnder.Down 	=	REdit.font.Underline
	tbleft.Down 	=	REdit.Paraleft
	tbcenter.Down 	=	REdit.Paracenter
	tbright.Down 	=	REdit.Pararight
	tbColor.TextColor = REdit.TextColor
End Sub
' --------- Menu Event sub ---------------
Sub menu_neu
	RichEditStart
	panel2.Caption = "NoFile"
End Sub
Sub menu_Open
	Dim s As String
	
	fopen.Filter = "All File|*.*|Text|*.txt|RTF|*.rtf"	
	fopen.FilterIndex = 3 ' auf rtf setzen
	If fopen.Execute(form1.Handle) Then
		REdit.PlainText = TRUE
		s = fopen.FileName
			panel2.Caption = s		
		If (Right(s,3)="rtf" ) Or (Right(s,3)="RTF" ) Then
			REdit.PlainText = FALSE
			REdit.LoadFile(s)
		Else
			REdit.LoadFile(s)
		EndIf	
	EndIf
End Sub

Sub menu_mnSaveAs	
	Dim s As String
	fsave.Filter = "All File|*.*|Text|*.txt|RTF|*.rtf"	
	fsave.FilterIndex = 3 ' auf rtf setzen
	If fsave.Execute(form1.Handle) Then
		REdit.PlainText = TRUE
		s = fsave.FileName
			panel2.Caption = s
		If (Right(s,3)="rtf" ) Or (Right(s,3)="RTF" ) Then
			REdit.PlainText = FALSE
			REdit.SaveFile(s)
		Else
			REdit.SaveFile(s)
		EndIf	
	EndIf
End Sub
Sub menu_Exit		
	form1.FormClose
End Sub
' ------------- TextFarbe ---------------
Sub tbColor_Click
	Dim As UInteger txColor = 0
	txColor = getColor(form1.Handle)
	If txColor <> -1 Then 
		REdit.TextColor = txColor
		tbColor.TextColor = txColor
		tbColor.Invalidate
		REdit.SelFontStyle
	End if
End Sub
' ------------ Schriftstil --------------
Sub tbBold_Click
	If REdit.font.Bold = 0 Then 		
		REdit.font.Bold = 1
		REdit.SelFontStyle
	Else 		
		REdit.font.Bold = 0
		REdit.SelFontStyle
	EndIf	
	GetRichEditStyle
End Sub
Sub tbItalic_Click	
	If REdit.font.Italic = 0 Then 		
		REdit.font.Italic = 1
		REdit.SelFontStyle
	Else 		
		REdit.font.Italic = 0
		REdit.SelFontStyle
	EndIf	
	GetRichEditStyle
End Sub
Sub tbUnder_Click
	If REdit.font.Underline = 0 Then 		
		REdit.font.Underline = 1
		REdit.SelFontStyle
	Else 		
		REdit.font.Underline = 0
		REdit.SelFontStyle
	EndIf
	GetRichEditStyle
End Sub
' -----------  Absatzstil  ------------ 
Sub tbleft_Click
	If REdit.Paraleft = 0 Then
		REdit.Paraleft = 1
		REdit.SelParaStyle
	Else
		REdit.Paraleft = 1
		REdit.SelParaStyle
	EndIf
	GetRichEditStyle
End Sub
Sub tbcenter_Click
	If REdit.Paracenter = 0 Then
		REdit.Paracenter = 1
		REdit.SelParaStyle
	Else
		REdit.Paracenter = 1
		REdit.SelParaStyle
	EndIf
	GetRichEditStyle
End Sub
Sub tbright_Click
	If REdit.Pararight = 0 Then
		REdit.Pararight = 1
		REdit.SelParaStyle
	Else
		REdit.Pararight = 1
		REdit.SelParaStyle
	EndIf
	GetRichEditStyle
End Sub
' ------------------Schriftart und Schrifthhe -----------
Sub combo1_SelChange(ByVal item As UInteger, szItem As ZString)	
	REdit.font.FaceName	=  szItem
	REdit.SelFontStyle
End Sub

Sub combo2_SelChange(ByVal item As UInteger, szItem As ZString)	
	REdit.font.Size = Val(szItem)
	REdit.SelFontStyle
End Sub
' -------------------- Size -----------
Sub Form1_onSize(ByVal w As Integer, ByVal h As Integer,ByVal flag As Integer)
	panel1.Width=w
	panel2.Width=w
	panel2.Top=h-27
	REdit.Width=w
	REdit.Height = h-62
End Sub
' ----------------------- 
'
Sub REdit_SelChange	
	GetRichEditStyle	
End Sub
' -------------------- Enum Schrift -----------------------------
Function MyenumProc(lpelf As ENUMLOGFONT Ptr,lpntm As NEWTEXTMETRIC Ptr, FontType As Integer, lParam 	As LPARAM) As Integer
   
	Dim As String s
	If FontType = TRUETYPE_FONTTYPE  Then
		s = lpelf->elfLogFont.lfFaceName
		combo1.AddString(s)
	End If	
	Return 1
		
End Function
Sub addFontToCombo
	Dim As Integer retVal 
	Dim As HDC dc
	Dim As LOGFONT lf
	Dim As LOGFONT Ptr lplf
	
	lplf = @lf
	lf.lfWeight = FW_NORMAL
	lf.lfItalic = FALSE
	lf.lfUnderline= FALSE
	lf.lfStrikeOut=FALSE
	
	dc = GetDC(form1.handle)
	retVal = EnumFontFamiliesEx(dc, lplf , Cast(FONTENUMPROC, @MyenumProc), Cast(LPARAM,0), 0 )
	ReleaseDC(form1.handle,dc)
	combo1.SelStrItem("Arial")  

	
End Sub
Sub addSizeToCombo
	Dim As Integer i
	Dim As String s
	
	For i = 8 To 32 Step 2
		s = Str(i)
		If Len(s) = 1 Then
			s = "0"+s
		EndIf
		combo2.AddString(s)
	Next
	combo2.SelStrItem("10") 
End Sub
