'-----------------------------------------------------------------------------------
' Hilfsfunction ( FILEEXISTS verursacht u.u. Absturz)
'-----------------------------------------------------------------------------------
Function isFileExist(file As String) As BOOL
	Dim szFile As ZString * MAX_PATH
	Function = FALSE
	szFile = file
	If GetFileAttributes(@szFile) <> &HFFFFFFFF Then
		Function = TRUE
	EndIf
End Function

'-----------------------------------------------------------------------------------
' Control
'-----------------------------------------------------------------------------------
Type Control Extends Object 	
  	Public:
  	Declare Constructor
   Declare Destructor 
  	Declare Property Left() As Integer							' Get  Left
   Declare Property Left( ByVal value As Integer )			' Set  Left
  	Declare Property Top() As Integer							' Get  Top
   Declare Property Top( ByVal value As Integer )			' Set  Top
	Declare Property Width() As Integer							' Get  Width
   Declare Property Width( ByVal value As Integer )		' Set  Width
  	Declare Property Height() As Integer						' Get  Height
   Declare Property Height( ByVal value As Integer )		' Set  Height
   Declare Property ClientHeight() As Integer				' Get  ClientHeight  
   Declare Property ClientWidth() As Integer					' Get  ClientWidth 
   Declare Property Caption as string							' Get  Caption
   Declare Property Caption(value as string)					' Set  Caption
   Declare Property Font() As HFONT								' Get  FontHandle
   Declare Property Style() As UInteger						' Get  Style
   Declare Property Style(ByVal value As UInteger)			' Set  Style
  	Declare Property ExStyle() As UInteger						' Get  ExStyle
  	Declare Property ExStyle(ByVal value As UInteger)		' Set  ExStyle
  	Declare Property Visible as Integer							' Get  Visible
   Declare Property Visible( ByVal value as Integer)		' Set  Visible	
   Declare Property Enabled as Integer							' Get  Enabled
   Declare Property Enabled( ByVal value as Integer)		' Set  Enabled
   Declare VIRTUAL Property TextColor() As UInteger					' Get  TextColor
   Declare VIRTUAL Property TextColor( ByVal value As UInteger )	' Set  TextColor   
   Declare VIRTUAL Property Color() As UInteger						' Get  HintergrundColor
   Declare VIRTUAL Property Color( ByVal value As UInteger )		' Set  HintergrundColor
   Declare Property Handle() As HWND							' Get  Handle Control
   Declare Property Handle( ByVal value As HWND )			' Set  Handle Control
   Declare Property Parent() As HWND							' Get  Handle
   Declare Property Parent( ByVal value As HWND )			' Set  Handle
   Declare Property CtHandle() As HWND							' Get Container Handle
	Declare Property CtHandle( ByVal value As HWND )		' Set Container Handle
	Declare Property Tip( ByVal value As String )			' Set  ToolTip
   ' Methods
   Declare Sub Invalidate
   Declare Sub Focus
	Declare Sub Repaint
	Declare Sub setFont(Face As String,ByVal size As Integer,ByVal bold As Integer,ByVal italic As Integer,ByVal underlin As Integer)
	Declare VIRTUAL Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT	
   Declare Static Function DispMsg(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   
   Private:
   Declare Sub DisplayToolTip
   As HWND		b_hwndTT
   As String	b_tooltip		= "" 
	As Short		b_Left			= 0
	As Short  	b_Top				= 0
   As Short 	b_Width 	 		= 0
  	As Short 	b_Height   		= 0
  	As HWND    	b_Handle   		= 0
  	As HWND    	b_Parent   		= 0
  	As HWND    	b_Cthandle 		= 0
  	As String 	b_Caption   	= ""
  	As UInteger	b_ExStyle		= 0
	As UInteger	b_Style 			= 0
	As Integer  b_Visible 		= SW_SHOWNORMAL
	As Integer  b_Enabled		= TRUE
	As UInteger	b_TextColor		= 0								' Vordergrund(Text) Schwarz
	As UInteger	b_Color			= &HDCDCDC						' Hintergrund hellgrau
	As HFONT		b_hFont			
End Type

Destructor Control
	' wird bei allen Objekten aufgerufen
	Dim As ZString * 128 szClass 
	Dim wcls as WNDCLASS   
	   
   szClass = "FB_CONTROL"
   If GetClassInfo(GetModuleHandle(0),@szClass,@wcls) <> 0 Then   
	 UnregisterClass(@szClass,GetModuleHandle(0))
	End if
   
	If this.b_hFont Then
		DeleteObject(this.b_hFont)
	EndIf	

End Destructor
Constructor Control	
	
	Dim wcls as WNDCLASS     
   Dim As ZString * 128 szClass
    
   szClass = "FB_CONTROL"
   ' Class fr die Conainer der Controls 
   If GetClassInfo(GetModuleHandle(0),@szClass,@wcls) = 0 Then               
	    with wcls
	    	.style         = CS_HREDRAW or CS_VREDRAW
	    	.lpfnWndProc   = @DispMsg
	    	.cbClsExtra    = 0
	    	.cbWndExtra    = 0
	    	.hInstance     = GetModuleHandle(0)
	    	.hIcon         = NULL
	    	.hCursor       = LoadCursor(NULL, IDC_ARROW )
	    	.hbrBackground = GetStockObject(WHITE_BRUSH)
	    	.lpszMenuName  = NULL
	    	.lpszClassName = @szClass
	    end with
	          
	    if( RegisterClass( @wcls ) = FALSE ) then
	       MessageBox( null, "Fehler - FB_CONTROL Class ist nicht registriert", "Error", MB_ICONERROR )
	    end if
   End If 
	
  	this.b_Handle 		= 0
  	this.b_Cthandle	= 0
  	this.ExStyle 		= 0	
	this.Style 	 		= WS_VISIBLE Or WS_CHILD
	this.b_Visible 	= SW_SHOWNORMAL
	this.b_Enabled		= TRUE
	this.b_TextColor 	= 0							
	this.b_Color		= &HDCDCDC	
	this.b_hFont		= GetStockObject(SYSTEM_FONT)	
		
end Constructor

Property Control.Font() As HFONT
	Return this.b_hFont
End Property
Property Control.Left() As Integer
  Return this.b_Left 
End Property
Property Control.Left( ByVal value As Integer )
	this.b_Left = value
	If this.b_Cthandle Then
		MoveWindow(this.b_Cthandle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	Else	
  		MoveWindow(this.b_Handle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	End If	
End Property
Property Control.Top() As Integer
  Return this.b_Top
End Property
Property Control.Top( ByVal value As Integer )
	this.b_Top = value
	If this.b_Cthandle Then
		MoveWindow(this.b_Cthandle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	Else	
  		MoveWindow(this.b_Handle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	End If	
End Property

Property Control.Width() As Integer
  Return this.b_Width 
End Property

Property Control.Width( ByVal value As Integer )
  	this.b_Width = value
	If this.b_Cthandle Then
		MoveWindow(this.b_Cthandle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	Else	
  		MoveWindow(this.b_Handle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	End If	
End Property

Property Control.Height() As Integer
  Return this.b_Height
End Property

Property Control.Height( ByVal value As Integer )
	this.b_Height = value
	If this.b_Cthandle Then
		MoveWindow(this.b_Cthandle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	Else	
  		MoveWindow(this.b_Handle,this.b_Left,this.b_Top,this.b_Width,this.b_Height ,TRUE)	
	End If	 
End Property

Property Control.ClientHeight() As Integer
	If this.b_Handle Then
		Dim rc As RECT
		GetClientRect(this.b_Handle,@rc)
		Return rc.bottom
	EndIf
End Property

Property Control.ClientWidth() As Integer
  	If this.b_Handle Then
		Dim rc As RECT
		GetClientRect(this.b_Handle,@rc)
		Return rc.right
	EndIf
End Property

Property Control.Handle() As HWND							' Get Handle
  Return this.b_Handle
End Property

Property Control.Handle(ByVal Value As HWND)				' Set Handle
  this.b_Handle = Value
End Property
Property Control.CtHandle() As HWND							' Get Container-Handle
  Return this.b_Cthandle
End Property
Property Control.CtHandle(ByVal Value As HWND)			' Set Container-Handle
  this.b_Cthandle = Value
End Property
Property Control.Parent() As HWND							' Get Handle
  Return this.b_Parent
End Property
Property Control.Parent(ByVal Value As HWND)				' Set Handle
  this.b_Parent = Value
End Property
Property Control.Caption as string							' Get Caption
   Return this.b_Caption
End Property
Property Control.Caption(value as string)    			' Set Caption
	If this.b_Handle Then
   	this.b_Caption = value 
    	SetWindowText(b_Handle,value) 
    	Repaint
	End If 	
end Property
Property Control.Style() As UInteger						' Get  Style
	 Return this.b_Style
end Property
Property Control.Style(ByVal value As UInteger)			' Set  Style
		this.b_Style = value
End Property
Property Control.ExStyle() As UInteger						' Get  ExStyle
	Return this.b_ExStyle
end Property
Property Control.ExStyle(ByVal value As UInteger)		' Set  ExStyle
		this.b_ExStyle = value	
end Property
Property Control.Enabled as Integer
	Return this.b_Enabled
End Property
Property Control.Enabled(ByVal value as Integer) 			' value = True : Enabled
	 this.b_Enabled = IIf(value,TRUE,FALSE)
	 If this.b_Handle Then
     EnableWindow(this.b_Handle,this.b_Enabled)
	 End If
End Property
Property Control.Visible as Integer
	Return this.b_Visible
End Property
Property Control.Visible(ByVal value as Integer) 			' value = 0 : SW_HIDE ; 1 : SW_SHOW		
	this.b_Visible = value	
	If this.b_Handle Then 
  		ShowWindow(this.b_Handle,IIf(value,SW_SHOW,SW_HIDE))	     
	End If
End Property
Property Control.TextColor() As UInteger						' Get  TextColor
	Return this.b_TextColor
end Property
Property Control.TextColor( ByVal value As UInteger )  	' Set  TextColor	
	If this.b_Handle Then
		this.b_TextColor = value
		Repaint
	End If		
end Property
Property Control.Color() As UInteger							' Get  HintergrundColor
	Return this.b_Color
End Property
Property Control.Color( ByVal value As UInteger )			' Set  Hintergrund Color 	
	If this.b_Handle Then
		this.b_Color = value
		Repaint
	End If		
end Property
Property Control.Tip( ByVal value As String )
	this.b_tooltip = value	
	If  (Len(this.b_tooltip) > 0) And (this.Handle > 0) Then
		DisplayToolTip 
	EndIf
End Property
 
Sub Control.DisplayToolTip 
	
	If InitCommon = 0 Then 
		InitCommonControls
		InitCommon = 1
	EndIf
	
	Dim AS TOOLINFO ti
	Dim szTip As ZString * 64
	
	If Len(this.b_tooltip) = 0 Then Exit Sub
	szTip = this.b_tooltip
	
	this.b_hwndTT = CreateWindow(TOOLTIPS_CLASS,  NULL, TTS_ALWAYSTIP, _ 
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, _
        NULL,  NULL, GetModuleHandle(0), NULL) 
   
   If  this.b_hwndTT Then    
	   ti.cbSize=sizeof(TOOLINFO)
	   ti.uFlags=TTF_SUBCLASS
	   If this.Handle Then
	   	ti.hwnd=this.Handle
	   End If	
	   ti.hinst=GetModuleHandle(0)
	   ti.lpszText=@szTip
	   GetClientRect(this.Handle, @ti.rect)
	   SendMessage(this.b_hwndTT, TTM_ADDTOOL, 0, CAST(LPARAM, @ti))
   End If 	
End Sub

Function Control.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
	
	Function = DefWindowProc(hWnd ,uMsg ,wParam , lParam )
	
End Function

Function Control.DispMsg(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT

	Dim obj As Control Ptr = Cast(Control Ptr,GetWindowLong(hWnd,GWL_USERDATA)) ' Zeiger auf Klasse die hWnd sendet
	
	If obj Then
		Function = obj->CtrlMsgFunc(hWnd ,uMsg ,wParam , lParam )
	Else
		Function = DefWindowProc(hWnd ,uMsg ,wParam , lParam )
	EndIf	
	
End Function
Sub Control.Focus
	If this.b_Handle Then 
	 	SetFocus(this.b_Handle)
	EndIf
End Sub
Sub Control.Invalidate
	 If this.b_Handle Then 
	 	InvalidateRect(this.b_Handle,0,TRUE)
	 EndIf
End Sub

Sub Control.Repaint
	 If this.b_Handle Then
	 	 RedrawWindow(this.b_Handle,0,0,RDW_ERASE Or RDW_INVALIDATE Or RDW_FRAME Or RDW_ALLCHILDREN)
	 EndIf
End Sub

Sub Control.setFont(Face As String,ByVal size As Integer,ByVal bold As Integer,ByVal italic As Integer,ByVal underlin As Integer)	
	Dim lgFont AS LOGFONT 
	lgFont.lfFaceName = Face
	lgFont.lfHeight 	= -MulDiv(size, GetDeviceCaps(GetDC(0), LOGPIXELSY), 72)
	lgFont.lfWeight 	= IIf(bold,800,400)
	lgFont.lfItalic 	= IIf(italic,1,0)
	lgFont.lfStrikeOut = 0
	lgFont.lfUnderline = IIf(underlin,1,0)
	If this.b_hFont Then
		DeleteObject(this.b_hFont)
	EndIf
	this.b_hFont = (CreateFontIndirect(@lgFont))	
	SendMessage(this.Handle,WM_SETFONT,Cast(Uinteger, this.b_hFont),TRUE)
End Sub
'                                          ###### Ende Basis #######                                       
'------------------------------------------------------------------------------------------
' FImage	 wird von Controls die Bilder laden verwendet
'------------------------------------------------------------------------------------------
Type FImage Extends Object  	
  	Public:
	Declare Property ImgWidth() As Integer					 
  	Declare Property ImgHeight() As Integer	
  	Declare Property ImgWidth(ByVal value  As Integer	)				 
  	Declare Property ImgHeight(ByVal value  As Integer	)					
   Declare Property DC() As HDC							
   Declare Property bkColor() As UInteger
   Declare Property bkColor( ByVal x As UInteger )   
   Declare Sub LoadImg(s As String)
   Declare Sub LoadRes(s As String)   
   Declare Sub ImgCopy(ByVal ZielDC As HDC, ByVal posx As Integer, ByVal posy As Integer)
   Declare Sub ImgCopyRect(ByVal ZielDC As HDC, tRC As RECT, qRC As RECT, ByVal rop As UInteger)
	Declare Destructor 
	
	Private:
   As Integer 	w 	 	= 0
  	As Integer 	h    	= 0
  	As HDC     	tdc   = 0
  	As UInteger bkC 	= &hffffffff
  
End Type

Property FImage.ImgWidth() As Integer
  Return this.w
End Property

Property FImage.ImgHeight() As Integer
  Return this.h
End Property
Property FImage.ImgWidth(ByVal value  As Integer	)		
	this.w = Value
End Property
Property FImage.ImgHeight(ByVal value  As Integer	)	
	this.h = value
End Property
Property FImage.bkColor() As UInteger
	Return this.bkC
End Property
Property FImage.bkColor( ByVal value As UInteger )	
	this.bkC = value	
End Property

Property FImage.DC() As HDC
  Return this.tdc
End Property
DESTRUCTOR FImage 
	If this.tdc <> 0 Then
  		DeleteDC(this.tdc)
	End If
End Destructor

Sub FImage.LoadImg(s As String)
	
	Using Gdiplus
	
	Dim As GdiplusStartupInput gdipsi
   Dim As ULONG_PTR gdipToken
   Dim As GpGraphics Ptr pGraph
   Dim As GpImage Ptr pImg
	Dim As HBITMAP bitmap
	Dim As UInteger w,h
	
	If this.tdc <> 0 Then
  		DeleteDC(this.tdc)
	End If
	
	gdipsi.GdiplusVersion = 1 
	If GdiplusStartup( @gdipToken, @gdipsi, null ) <> 0 Then
		Exit sub
	EndIf
	If GdipLoadImageFromFile( WStr(s), @pImg) <> 0 Then
  		GdiplusShutdown( gdipToken )
  		Exit Sub
	EndIf
	
	If GdipGetImageWidth (pImg, @w) = 0 Then
		this.ImgWidth = w 
	EndIf
	If GdipGetImageHeight (pImg, @h) = 0 Then
		this.ImgHeight = h 
	EndIf
			
	Dim As HDC tmpDC = GetDC(GetDesktopWindow)
   this.tdc = CreateCompatibleDC(tmpDC)
   bitmap = CreateCompatibleBitmap(tmpDC,w,h)
	SelectObject(this.tdc,bitmap)
	
	ReleaseDC(GetDesktopWindow,tmpDc)
	DeleteObject(bitmap)
	
	GdipCreateFromHDC(this.tdc , @pGraph)
	GdipGraphicsClear(pGraph,this.bkColor)
	GdipDrawImageRect(pGraph, pImg, 0, 0, w, h)
		
	'Image und Objekt freigeben
	GdipDisposeImage( pImg)
	GdipDeleteGraphics(pGraph)
	GdiplusShutdown( gdipToken )	
	
End Sub
'---------------------- Nur Bitmap ---------------------
Sub FImage.LoadRes(resName As String) 
	
	Dim As HINSTANCE hInst
   Dim As ZString * 128 szRes 
   Dim As BITMAP bm2	
  
	If this.tdc <> 0 Then
  		DeleteDC(this.tdc)
	End If
	
	hInst 	= GetModuleHandle(0)
	szRes		= resName
	
	Dim As HDC hDC = GetDC(GetDesktopWindow)						
   this.tdc	= CreateCompatibleDC(hDC)	
	
	Dim As HBITMAP hBmp	= LoadBitmap(hInst , cast( LPCSTR, @szRes ))	
	If hBmp  = 0 Then
		MessageBox( null, "Fehler - Bitmap ist nicht gefunden", "Error", MB_ICONERROR )
		Exit Sub
	EndIf
			
	GetObject(hBmp,SizeOf(bm2),@bm2)
	this.ImgWidth = bm2.bmWidth 
	this.ImgHeight = bm2.bmHeight 
	
	SelectObject(this.tdc,hBmp)
	DeleteObject(hBmp)
	ReleaseDC(GetDesktopWindow,hDC)
	
End Sub

Sub FImage.ImgCopy(ByVal ZielDC As HDC,  ByVal zielX As Integer, ByVal zielY As Integer)
	
	If this.tdc<>0 Then
		BitBlt(ZielDC,zielX,zielY,this.ImgWidth,this.ImgHeight,this.tdc,0,0,SRCCOPY)
	EndIf
	
End Sub
Sub FImage.ImgCopyRect(ByVal ZielDC As HDC, tRC As RECT, qRC As RECT, ByVal rop As UInteger)
	
	Dim As UInteger iRop
	
	If rop = 0 Then
		iRop = SRCCOPY
	Else
		iRop = rop
	EndIf
	
	If this.tdc<>0 Then
		StretchBlt(ZielDC,tRC.left,tRC.top,tRC.right,tRC.bottom ,this.tdc,qRC.left,qRC.top,qRC.right,qRC.bottom ,iRop)
	EndIf
	
End Sub
'------------------------------------------------------------------------------------------
' Bitmap oder Icon Laden + Handle  bereit stellen
'------------------------------------------------------------------------------------------
Type FBILoad Extends Object  	
  	Public:
	Declare Property bWidth() As Integer					
   Declare Property bWidth( ByVal x As Integer )		
  	Declare Property bHeight() As Integer					
   Declare Property bHeight( ByVal x As Integer )		
   Declare Property bBitmap() As HBITMAP					
   Declare Property bIcon() As HICON	
   Declare Sub LoadBitmapFile( filename As String) 
	Declare Sub LoadIconFile( filename As String)  
	Declare Sub LoadBitmapRes( filename As String) 
	Declare Sub LoadIconRes( filename As String) 
	Declare Function CopyhBitmap As HBITMAP
	Declare Function CopyhIcon As HICON 
	Declare DESTRUCTOR  
	Private:
   As Integer 	w 	 			= 0
  	As Integer 	h    			= 0
   As HBITMAP	b_Bitmap 	= 0
   As HICON		b_Icon	 	= 0
End Type

DESTRUCTOR FBILoad
	If this.b_Bitmap Then
		DeleteObject(this.b_Bitmap)
	EndIf
End Destructor
Property FBILoad.bWidth() As Integer
  Return this.w
End Property
Property FBILoad.bWidth( ByVal x As Integer )
  this.w = x
End Property
Property FBILoad.bHeight() As Integer
  Return this.h
End Property
Property FBILoad.bHeight( ByVal x As Integer )
  this.h = x
End Property

Property FBILoad.bBitmap() As HBITMAP	
	Return this.b_Bitmap
End Property
Property FBILoad.bIcon() As HICON	
	Return this.b_Icon
End Property
Sub FBILoad.LoadBitmapFile( filename As String) 
	Dim szFile As ZString * 128
	Dim As BITMAP bm
	
	If isFileExist(filename) = FALSE Then
		Exit sub
	EndIf
	szFile = filename
	If this.b_Bitmap Then
		DeleteObject(this.b_Bitmap)
	EndIf
	
	this.b_Bitmap = LoadImage(NULL,@szFile,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR Or LR_LOADFROMFILE )
	
	If this.b_Bitmap Then
		GetObject(this.b_Bitmap,SizeOf(bm),@bm)
		this.w = bm.bmWidth
		this.h = bm.bmHeight		
	EndIf
End Sub
Sub FBILoad.LoadIconFile( filename As String)  
	Dim szFile As ZString * 128
	If isFileExist(filename) = FALSE Then
		Exit sub
	EndIf
	szFile = filename
	this.b_Icon = LoadImage(NULL,@szFile,IMAGE_ICON,0,0,LR_DEFAULTCOLOR Or LR_LOADFROMFILE )
	If this.b_Icon Then
		this.w = GetSystemMetrics(SM_CXICON)
		this.h = GetSystemMetrics(SM_CYICON)	
	EndIf
End Sub
Sub FBILoad.LoadBitmapRes( resname As String) 
	Dim szFile As ZString * 128
	Dim As HINSTANCE hInst = GetModuleHandle(0)
	Dim As BITMAP bm
	
	If this.b_Bitmap Then
		DeleteObject(this.b_Bitmap)
	EndIf
	szFile = resname
	this.b_Bitmap = LoadImage(hInst,@szFile,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR )
	If this.b_Bitmap Then
		GetObject(this.b_Bitmap,SizeOf(bm),@bm)
		w = bm.bmWidth
		h = bm.bmHeight		
	EndIf	
End Sub
Sub FBILoad.LoadIconRes( resname As String) 
	Dim szFile As ZString * 128
	Dim As HINSTANCE hInst = GetModuleHandle(0)
	szFile = resname
	this.b_Icon = LoadImage(hInst,@szFile,IMAGE_ICON,0,0,LR_DEFAULTCOLOR  )
	If this.b_Icon Then
		this.w = GetSystemMetrics(SM_CXICON)
		this.h = GetSystemMetrics(SM_CYICON)	
	EndIf
End Sub
Function FBILoad.CopyhBitmap As HBITMAP
	
	Return CopyImage(this.b_Bitmap,IMAGE_BITMAP,this.w,this.h,LR_COPYDELETEORG)

End Function
Function FBILoad.CopyhIcon As HICON
	Return CopyImage(this.b_Bitmap,IMAGE_ICON,this.w,this.h,LR_COPYDELETEORG)
End Function


'=========================================================================================================