
'--------------------------------------------------------------------
'Button 				Checkbox
'--------------------------------------------------------------------
Type FCheckbox Extends Control	
	public: 	    
	Declare Property Check As Integer
	Declare Property Check(ByVal value As Integer)
	Declare Sub Create(ByVal hParent As HWND, Capt As String,ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Constructor
   Declare Destructor  
   ' Events	
	onClick As Sub()	 
   Declare  Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   Private: 
   As Integer b_Check	= 0
   As HBRUSH  b_Brush	= 0
End Type
Constructor FCheckbox	
  	this.Handle  = 0
  	this.ExStyle = 0	
  	this.b_Check = 0
	this.Style 	 =  WS_CHILD Or WS_VISIBLE Or BS_AUTOCHECKBOX Or WS_TABSTOP 
end Constructor

Destructor FCheckbox	
	If this.b_Brush Then
		DeleteObject(this.b_Brush)
	EndIf
   this.Handle  = 0
End Destructor
Property FCheckbox.Check As Integer
	If this.Handle Then
		this.b_Check = SendMessage(this.Handle,BM_GETCHECK,0,0)
		Return this.b_Check
	End If
End Property
Property FCheckbox.Check(ByVal value As Integer)
	If this.Handle Then
		SendMessage(this.Handle,BM_SETCHECK ,IIf(value,BST_CHECKED,BST_UNCHECKED) ,0)
		this.b_Check = IIf(value,BST_CHECKED,BST_UNCHECKED)
	EndIf
End Property
Function FCheckbox.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
	
   Function = 0 
   Static As BOOL flEnable = TRUE
    
   Select Case uMsg
   	
   Case WM_ENABLE 
   		flEnable = wParam
   		Exit Function
   		
   Case WM_SETFONT,WM_SETTEXT
   		If this.Handle Then
   			Function = SendMessage(this.Handle,uMsg,wParam,lParam)
   		End If
    		Exit Function 
    		
   	Case WM_SIZE
   		If this.Handle Then
    			MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
   		End If
    		Exit Function 
   	
   Case WM_COMMAND		  		
   		If IsChild( hWnd, Cast(HANDLE, lParam)) Then 
   			If this.onClick Then
  					onClick()
   			End If  							
   		Function = 0
   		Exit Function   
   		EndIf
   		
    Case WM_CTLCOLORSTATIC
   	If IsChild(hWnd,Cast(HANDLE, lParam)) Then
   		If flEnable Then
   			SetTextColor(Cast(HDC, wParam),this.TextColor)
   		Else
   			SetTextColor(Cast(HDC, wParam),&HA0A0A0)
   		End If	
   		SetBkMode(Cast(HDC, wParam),TRANSPARENT)
   		If this.b_Brush Then
   			DeleteObject(this.b_Brush)
   		EndIf
   		this.b_Brush = CreateSolidBrush(this.Color)
   		Function = Cast(LRESULT,this.b_Brush)
   	End If	 		
   	Exit Function
   	
   End Select 	
   Function = DefWindowProc(hWnd,uMsg,wParam,lParam)
end Function
Sub FCheckbox.Create(ByVal hParent As HWND, Capt As String,ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	        
   Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst
 	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
      
   this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE Or WS_CHILD  , x, y, w , h , _                    
                          hParent , NULL, hInst , NULL )
                                                   
   SetWindowLong(this.CtHandle ,GWL_USERDATA,CInt(@This)) ' Zeiger diese Instanz                        
                                                                    
   If this.CtHandle  Then  		
   	this.Left	 = x
		this.Top		 = y
   	this.Width 	 = w
  		this.Height  = h
   	this.Parent  = hParent  	
   Else
   	MessageBox(0,"Fehler - Create Button","Fehler",MB_ICONERROR)
   	Exit Sub
   End If
                            
    
   this.Handle = CreateWindowEx( NULL , "BUTTON" , Capt, this.Style  ,  0, 0, w, h , this.CtHandle , NULL, hInst , NULL )                                            
   If this.Handle = 0 Then
   	MessageBox(0,"Fehler - Create Button","Fehler",MB_ICONERROR)
   EndIf  
   this.Caption = Capt   
End Sub
