'--------------------------------------------------------------------
' 		Edit
'-------------------------------------------------------------------- 
Type FEdit Extends Control
	
	public:		    
   Declare Property Border(ByVal value As Integer)
   Declare Property TextLen As Integer
   Declare Property Number(ByVal value As Integer)
   Declare Property Password(ByVal value As Integer)
	Declare Property Text As String 
	Declare Property Text(sText As String )
   Declare Constructor
   Declare Destructor
   Declare Sub Clear 
   Declare Sub Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer)
   DECLARE  FUNCTION CtrlMsgFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT  
   ' Events	
	onChange  As SUB()	
	onUpdate As Sub()
	OnKeyDown As Sub(nKey AS Integer,lKeyStatus As Integer)
	OnSetFocus As Sub(ByVal hWnd As HWND)	
	Private: 
	DECLARE static FUNCTION EditSubClassFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT  
	As String	b_Text		= ""
   As HBRUSH	b_Brush		= 0
   As UInteger b_oldProc	= 0
End Type
Constructor FEdit
  	this.Handle  = 0
  	this.Handle = 0
  	this.Color   = &HFFFFFF
  	this.ExStyle = WS_EX_CLIENTEDGE 
	this.Style 	 = WS_CHILD  Or WS_TABSTOP Or ES_AUTOHSCROLL 
end Constructor
Destructor FEdit	
	If this.b_Brush Then
		DeleteObject(this.b_Brush)
	EndIf	
	If this.Handle Then
		SetWindowLong(this.Handle, GWL_WNDPROC, this.b_oldProc)
	End If
	this.Handle = 0
end Destructor
Property FEdit.Password(ByVal value As Integer)
	If this.Handle Then
		If value = 0 Then
			SendMessage(this.Handle,EM_SETPASSWORDCHAR,0,0)
		Else
			SendMessage(this.Handle,EM_SETPASSWORDCHAR,Cast(WPARAM,Asc("*")) ,0)
		EndIf
		Repaint
	EndIf
End Property
Property FEdit.Border(ByVal Value As Integer)

	If this.Handle Then	
		
		Select Case value
			Case 0				' Ohne
				this.Style = WS_CHILD  Or WS_TABSTOP Or ES_AUTOHSCROLL Or WS_VISIBLE
				this.ExStyle  = 0
			Case 1				' Sunken
				this.Style = WS_CHILD  Or WS_TABSTOP Or ES_AUTOHSCROLL  Or WS_VISIBLE
				this.ExStyle  = WS_EX_CLIENTEDGE
			Case 2				' Border
				this.Style = WS_CHILD  Or WS_TABSTOP Or ES_AUTOHSCROLL or WS_BORDER  Or WS_VISIBLE
				this.ExStyle  = 0
		End Select
		SetWindowLong(this.Handle,GWL_STYLE,this.Style)
		SetWindowLong(this.Handle,GWL_EXSTYLE,this.ExStyle)
		SetWindowPos(this.Handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	EndIf	
End Property

Property FEdit.Number(ByVal value As Integer)
	If this.Handle Then
		Dim Styl As UInteger
		Styl = GetWindowLong(this.Handle,GWL_STYLE)
		If value = 0 Then
			this.Style = Styl And (Not ES_NUMBER)
		Else
			SendMessage(this.Handle, WM_CLEAR, 0, 0)
			this.Style = Styl or ES_NUMBER
		EndIf
		SetWindowLong(this.Handle, GWL_STYLE, this.Style)
	EndIf
End Property

Property FEdit.TextLen As Integer
	If this.Handle Then
		Return GetWindowTextLength(this.Handle) 
	EndIf
End Property
Property FEdit.Text As String 	
	If this.Handle Then	
		Dim  As Integer maxCount,i
		maxCount = GetWindowTextLength(this.Handle) 
		this.b_Text = String(maxCount+2,Chr(0))  
		i = GetWindowText(this.Handle , StrPtr(this.b_Text) , maxCount+1 )	
		Return this.b_Text
	EndIf
End Property
Property FEdit.Text(sText As String )
	If this.Handle Then
		this.b_Text = sText
		SetWindowText(this.Handle ,sText)		
	EndIf
End Property

Sub FEdit.Clear
	If this.Handle Then
		SendMessage(this.Handle, WM_CLEAR, 0, 0)
	EndIf
End Sub
Function FEdit.EditSubClassFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
	
	Function = 0
	Dim As Integer lKeyDat = 0
	
	Dim as FEdit ptr Edit = cast(FEdit Ptr,GetWindowLong(hWnd,GWL_USERDATA)) ' Zeiger auf diese Klasse
	
	If Edit = 0 Then
		function = DefWindowProc(  hWnd, uMsg, wParam, lParam) 
		Exit Function
	EndIf
	
	Select case uMsg 
		Case WM_SETFOCUS 
			If Edit->OnSetFocus Then Edit->OnSetFocus(hWnd)	
				Function = CallWindowProc( Cast(Any Ptr,Edit->b_oldProc), hWnd, uMsg, wParam, lParam) 
			Exit Function
			
		Case WM_GETDLGCODE  
   		Function = DLGC_WANTALLKEYS	
			Exit Function	
			
		Case WM_KEYDOWN			
			If GetKeyState(VK_SHIFT) < -126 Then
				lKeyDat = VK_SHIFT	'&H10
			ElseIf GetKeyState(VK_CONTROL) < -126 Then	
				lKeyDat = VK_CONTROL	'&H11
			ElseIf GetKeyState(VK_MENU) < -126 Then		
				lKeyDat = VK_MENU		'&H12
			End If	
				
   		If Edit->OnKeyDown Then Edit->OnKeyDown(wParam,lKeyDat)	
   		'SetFocus(hWnd) 
   		function = CallWindowProc( Cast(Any Ptr,Edit->b_oldProc), hWnd, uMsg, wParam, lParam) 
   		Exit Function	  	
	End Select
	
	function = CallWindowProc( Cast(Any Ptr,Edit->b_oldProc), hWnd, uMsg, wParam, lParam) 
End Function
Function FEdit.CtrlMsgFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
     	   
     	   
   SELECT CASE uMsg
        CASE WM_ENABLE
         this.Enabled = wParam
         EXIT FUNCTION

        CASE WM_SETFONT,WM_SETTEXT
         IF this.Handle THEN
             FUNCTION = SendMessage(this.Handle,uMsg,wParam,lParam)
         END IF
         EXIT FUNCTION

        CASE WM_SIZE
         IF this.Handle THEN
             MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
         END IF
         EXIT FUNCTION          
   				
   	Case WM_CTLCOLOREDIT
			SetBkColor(Cast(HDC, wParam),this.Color)
   		SetTextColor(Cast(HDC, wParam),this.TextColor ) 
   		If this.b_Brush Then
   			DeleteObject(this.b_Brush)
   		EndIf
   		this.b_Brush = CreateSolidBrush(this.Color)
   		Function = Cast(LRESULT,this.b_Brush ) 	 		
	      Exit Function  
	      		
   	Case  WM_COMMAND    		
   		If HiWord(wParam) = EN_CHANGE Then 
   			If this.onChange Then onChange() 	
   			Function = 0
   			Exit Function
   		End If
   		If HiWord(wParam) = EN_UPDATE  Then 
   			If this.onUpdate Then onUpdate() 	
   			Function = 0
   			Exit Function
   		End If
   End Select 
   
   function = DefWindowProc(  hWnd, uMsg, wParam, lParam)  
end Function

Sub FEdit.Create(ByVal hParent As HWND,ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	      
   
   DIM AS ZString * 32 szClass
   DIM AS HINSTANCE hInst

   szClass     = "FB_CONTROL"
   hInst        = GetModuleHandle(0)

   this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE OR WS_CHILD  , x, y, w , h , _
                          hParent , NULL, hInst , NULL )

   SetWindowLong(this.CtHandle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz

   IF this.CtHandle  THEN
        this.Left    = x
        this.Top     = y
        this.Width   = w
        this.Height  = h
        this.Parent  = hParent
   ELSE
        MessageBox(0,"Fehler - Create EDIT","Fehler",MB_ICONERROR)
        EXIT SUB
   END IF

   this.Handle = CreateWindowEx( this.ExStyle ,"EDIT" , "" , this.Style  , 0, 0, w, h , this.CtHandle , NULL, hInst , NULL )
   IF this.Handle = 0 THEN
        MessageBox(0,"Fehler - Create EDIT","Fehler",MB_ICONERROR)
        Exit Sub
   EndIf  
	this.b_oldProc = SetWindowLong( this.Handle, GWL_WNDPROC, CInt(@FEdit.EditSubClassFunc))
	SetWindowLong(this.Handle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz
   ShowWindow(this.Handle,SW_SHOW)
   
End Sub
