
'---------------------------------------------------------------------------------------------------------
' ListView
'--------------------------------------------------------------------------------------------------------- 
Type FListView Extends Control	
	public:		    
  	Declare Property SetView(ByVal value As Integer)
  	Declare Property SetView As Integer
  	Declare Property CheckBoxes(ByVal value As Integer)
  	Declare Property CheckBoxes As Integer
  	Declare Property GridLine(ByVal value As Integer)
  	Declare Property GridLine As Integer
  	Declare Property AutoSort(ByVal value As Integer)
  	Declare Property UserSort(ByVal value As Integer)
   Declare Property UserSort  As Integer
  	
  	Declare Property Border(ByVal value As Integer)
   Declare Property TexTColor(ByVal value As UInteger) OVERRIDE
   Declare Property TexTColor As UInteger OVERRIDE
   Declare Property Color(ByVal value As UInteger) OVERRIDE
   Declare Property Color As UInteger OVERRIDE
   Declare Property RowCount  As Integer
   Declare Property ColCount  As Integer  
   Declare Property ImgSmall(ByVal value As HANDLE)
   Declare Property ImgLarge(ByVal value As HANDLE)
   Declare Constructor
   Declare Destructor
   Declare Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT 
   Declare Function IsCheck( ByVal nItem As Integer) As Integer
   Declare Sub SetCheck( ByVal nItem As Integer,ByVal check As Integer)
   Declare Sub Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	Declare Sub AddColum(sName As String,ByVal nWidth As Integer,ByVal align As Integer)
	Declare Function AddItem(text As String , ByVal bildNr As Integer ) As Integer
	Declare Sub AddSubItem(ByVal row As Integer,ByVal col As Integer,text As String)
	Declare Sub GetItemText( ByVal iItem As Integer, ByVal iSubItem As Integer, sText As String)
	Declare sub DelItem(ByVal idx As Integer)
   Declare sub Clear
  		
   ' Events	
	onDblClick As SUB( ByVal item As Integer,szItem As ZString)	
	onClick As SUB( ByVal item As Integer,szItem As ZString)	
	onReturn As Sub( ByVal item As Integer,szItem As ZString)
	onLButtondown As Sub(ByVal  nItem As Integer,ByVal  nSubItem As Integer)	
	onColumClick As Sub( ByVal Colum As Integer)	
	Declare Static Function SortierFunc(ByVal lParam1 As LPARAM , ByVal lParam2 as LPARAM,  ByVal lParamSort as UInteger) As Integer	
	
	Private: 
	Declare Function EndLabelEdit( ByVal lParam As LPARAM ) as BOOL
	Declare Sub GetHitedItem( ByVal lParam As LPARAM, ByRef nItem As integer, ByRef nSubItem As Integer)
	Declare Sub FixedItem
	
   As Integer  b_LastCol	= 0
   As Integer  b_LastRow	= 0
   As Integer  b_UserSort	= 0 ' 0 nein,  1 string aufsteigend, 2 val aufsteigend, 3 string absteigend, 4 val absteigend
   As Integer  b_CurCol		= 0
	As Integer  b_GridLine	= TRUE
	As Integer  b_CheckBoxes= FALSE
	As Integer  b_View		= 0
End Type

Constructor FListView
	
	If InitCommon = 0 Then 
		InitCommonControls
		InitCommon = 1
	EndIf
	
	this.Handle  = 0
  	this.ExStyle	= WS_EX_LEFT  OR WS_EX_RIGHTSCROLLBAR Or WS_EX_CLIENTEDGE 
	this.Style 	= WS_CHILD OR WS_VISIBLE OR WS_TABSTOP OR LVS_REPORT Or LVS_SINGLESEL Or LVS_AUTOARRANGE Or LVS_SORTASCENDING
End Constructor

Destructor FListView
   this.Handle  = 0
End Destructor
Property FListView.UserSort(ByVal value As Integer)
	this.b_UserSort = value
End Property
Property FListView.UserSort  As Integer
	Return this.b_UserSort
End Property
   
Property FListView.AutoSort(ByVal value As Integer) ' 0 none  1 aufteigend(def) , 2 = absteigend
	If this.Handle Then			
		Select Case value
			Case 0
				this.Style = this.Style And (not LVS_SORTASCENDING)
				this.Style = this.Style And (not LVS_SORTDESCENDING)
			Case 1
				this.Style = this.Style Or LVS_SORTASCENDING
				this.Style = this.Style And (not LVS_SORTDESCENDING)
				this.b_UserSort = 0
			Case 2
				this.Style = this.Style Or LVS_SORTDESCENDING
				this.Style = this.Style And (not LVS_SORTASCENDING)
				this.b_UserSort = 0
		End Select
		SetWindowLong(this.Handle,GWL_STYLE,this.Style)
		UpdateWindow(this.Handle)
	EndIf
End Property
Property FListView.CheckBoxes(ByVal value As Integer)
	Dim As UInteger lStyle
	If this.Handle Then	
		If value Then
			this.b_CheckBoxes = TRUE
			lStyle = ListView_GetExtendedListViewStyle(this.Handle )
			ListView_SetExtendedListViewStyle(this.Handle, lStyle OR LVS_EX_CHECKBOXES )
		Else
			this.b_CheckBoxes = FALSE
			lStyle = ListView_GetExtendedListViewStyle(this.Handle )
			ListView_SetExtendedListViewStyle(this.Handle, lStyle And (Not LVS_EX_CHECKBOXES ))
		EndIf		
	EndIf
End Property
Property FListView.CheckBoxes As Integer
	Return this.b_CheckBoxes
End Property
Property FListView.GridLine As Integer
	Return this.b_GridLine
End Property
Property FListView.GridLine(ByVal value As Integer)
	Dim As UInteger lStyle
	If this.Handle Then	
		If value Then
			this.b_GridLine = TRUE
			lStyle = ListView_GetExtendedListViewStyle(this.Handle )
			ListView_SetExtendedListViewStyle(this.Handle, lStyle OR LVS_EX_GRIDLINES )
		Else
			this.b_GridLine = FALSE
			lStyle = ListView_GetExtendedListViewStyle(this.Handle )
			ListView_SetExtendedListViewStyle(this.Handle, lStyle And (Not LVS_EX_GRIDLINES ))
		EndIf		
	EndIf
End Property

Property FListView.Border(ByVal value As Integer)	' 0 ohne 1=sunken 2=Rahmen
	If this.Handle Then	
		Select Case value
			Case 0
				this.Style = this.Style And (Not WS_BORDER) 
				this.ExStyle = this.ExStyle And (Not WS_EX_CLIENTEDGE) 
			Case 1
				this.Style = this.Style And (Not WS_BORDER) 
				this.ExStyle = this.ExStyle Or WS_EX_CLIENTEDGE 
			Case 2	
				this.Style = this.Style or WS_BORDER 
				this.ExStyle = this.ExStyle And (Not WS_EX_CLIENTEDGE) 
		End Select
		SetWindowLong(this.Handle,GWL_STYLE,this.Style)
		SetWindowLong(this.Handle,GWL_EXSTYLE,this.ExStyle)
		SetWindowPos(this.Handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	EndIf
End Property
  	
Property FListView.ImgSmall(ByVal value As HANDLE)
	If this.Handle Then
		
		Dim As HIMAGELIST hOldIMGList = ListView_SetImageList( this.Handle, value , LVSIL_SMALL)
		If hOldIMGList Then
	 		ImageList_Destroy(hOldIMGList)
		EndIf
		
	End If 
End Property
Property FListView.ImgLarge(ByVal value As HANDLE)
	If this.Handle Then
		
		Dim As HIMAGELIST hOldIMGList = ListView_SetImageList( this.Handle, value , LVSIL_NORMAL)
		If hOldIMGList Then
	 		ImageList_Destroy(hOldIMGList)
		EndIf
		
	End If 
End Property
Property FListView.SetView  As Integer
	Return this.b_View 
End Property
Property FListView.SetView(ByVal value As Integer) '1=LVS_ICON 2=LVS_SMALLICON 3=LVS_LIST 0=LVS_REPORT
	If this.Handle Then
		Dim As Short wView
		Select Case value
			Case 1
				wView = LVS_ICON
				this.b_View = 1
			Case 2
				wView = LVS_SMALLICON
				this.b_View = 2
			Case 3
				wView = LVS_LIST
				this.b_View = 3
			Case Else
				wView = LVS_REPORT
				this.b_View = 0
		End Select
		
		Dim As UInteger dwStyle = GetWindowLong(this.Handle, GWL_STYLE)
		If (dwStyle and LVS_TYPEMASK) <> wView Then
	      SetWindowLong(this.Handle, GWL_STYLE, (dwStyle And (Not LVS_TYPEMASK)) Or wView)
		End If 
	End If 
End Property

Property FListView.TexTColor(ByVal value As UInteger) ' Text-Farbe
	If this.Handle Then
		SendMessage(this.Handle,LVM_SETTEXTCOLOR,0,value)
		repaint
	EndIf
End Property
Property FListView.TexTColor As UInteger
	If this.Handle Then
		Return SendMessage(this.Handle,LVM_GETTEXTCOLOR,0,0)
	EndIf
End Property
Property FListView.Color(ByVal value As UInteger)  ' Hintergrund der Nicht-Text-Bereiche
	If this.Handle Then
		SendMessage(this.Handle,LVM_SETTEXTBKCOLOR ,0, value)
		SendMessage(this.Handle,LVM_SETBKCOLOR , 0 , value)
		repaint
	EndIf
End Property
Property FListView.Color As UInteger 
	If this.Handle Then
		Return SendMessage(this.Handle,LVM_GETBKCOLOR,0,0)
	EndIf
End Property
 
Property FListView.RowCount  As Integer
	Return this.b_LastRow
End Property
Property FListView.ColCount  As Integer
		Return this.b_LastCol
End Property
Function FListView.IsCheck( ByVal nItem As Integer) As Integer
	If (nItem >=0) And  (nItem < this.RowCount) Then
		Return SendMessage(this.Handle, LVM_GETITEMSTATE, nItem, LVIS_STATEIMAGEMASK) - 4096
	End If 	
End Function
Sub FListView.SetCheck( ByVal nItem As Integer, ByVal check As Integer)
	If (nItem >=0) And  (nItem < this.RowCount) Then
		Dim ms_lvi AS LV_ITEM
      ms_lvi.stateMask = LVIS_STATEIMAGEMASK
      ms_lvi.state = IIf(check,8192,4096)
      SendMessage(this.Handle, LVM_SETITEMSTATE, nItem, CInt(@ms_lvi))
	End If 
End Sub
Sub FListView.DelItem( ByVal idx As Integer)
	ListView_DeleteItem(this.Handle,idx)
	this.b_LastCol = this.b_LastCol - 1
End Sub
sub FListView.Clear
	If this.Handle Then
		SendMessage(this.Handle,LVM_DELETEALLITEMS,0,0)
	EndIf
End Sub

Sub FListView.AddColum(sName As String,ByVal nWidth As Integer, ByVal align As Integer )
	
		Dim tLVC   AS LV_COLUMN
		Dim szBuf  AS zString * 128
		
		Select Case align			
			Case 1
				tLVC.fmt     = LVCFMT_CENTER	
			Case 2
				tLVC.fmt     = LVCFMT_RIGHT
			Case Else
				tLVC.fmt     = LVCFMT_LEFT	
		End Select
				
		tLVC.mask    = LVCF_FMT OR LVCF_TEXT OR LVCF_SUBITEM Or LVCF_WIDTH 
		tLVC.fmt     = align
		tLVC.pszText = @szBuf
		
		szBuf       	 = sName
		tLVC.iSubitem 	 = this.b_LastCol
		tLVC.cx     	 = nWidth
		this.b_LastCol = ListView_InsertColumn(this.Handle, this.b_LastCol, @tLVC ) + 1
End Sub

Function FListView.AddItem(text As String, ByVal bildNr As Integer ) As Integer
									' lCol = 0 Item
									' lCol > 0 SubItem
		Dim lvi    AS LV_ITEM
		Dim szTxT  AS ZString * MAX_PATH 
		
		szTxT = text
		lvi.stateMask  = LVIS_FOCUSED
		lvi.pszText    = @szTxT
		lvi.iItem      = this.b_LastRow
		lvi.iSubItem 	= 0
		lvi.lParam   	= this.b_LastRow
		lvi.iImage		= bildNr

		If bildNr = -1 Then
			lvi.mask = LVIF_TEXT OR LVIF_PARAM OR LVIF_STATE
		Else
			lvi.mask = LVIF_TEXT OR LVIF_PARAM OR LVIF_STATE Or LVIF_IMAGE	
		End If	
		this.b_LastRow = ListView_InsertItem(this.Handle, @lvi)
		Function = this.b_LastRow
		
		this.b_LastRow = this.b_LastRow + 1

End Function
Sub FListView.AddSubItem(ByVal row As Integer,ByVal col As Integer,text As String)
									
		Dim lvi    AS LV_ITEM
		Dim szTxT  AS ZString * MAX_PATH 
		
		If Col > this.b_LastCol Then Exit Sub
		If Col = 0 Then Exit Sub
		
		szTxT = text
		lvi.stateMask  = LVIS_FOCUSED
		lvi.pszText    = @szTxT
		lvi.iItem      = row
		lvi.iSubItem 	= col
		lvi.lParam   	= row
		lvi.iImage		= -1
		lvi.mask = LVIF_TEXT 
		ListView_SetItem(this.Handle, @lvi)
	
End Sub


Function FListView.EndLabelEdit( ByVal lParam As LPARAM ) as BOOL 
	Dim AS LPNMLVDISPINFOA pnmv = Cast(Any Ptr, lParam)

	if pnmv->item.iItem = -1 Then return FALSE 
	
	Dim pszItem As ZString Ptr
	pszItem = Cast(ZString Ptr, pnmv->item.lParam)
	LocalReAlloc( pszItem, lstrlen(pnmv->item.pszText) + 1,LMEM_MOVEABLE) 
    
   lstrcpy(pszItem, pnmv->item.pszText) 
 
   Return TRUE

End Function
Function FListView.SortierFunc(ByVal lParam1 As LPARAM , ByVal lParam2 as LPARAM,  ByVal lParamSort as UInteger) As Integer	
	Dim As FListView Ptr pList = Cast(FListView Ptr,lParamSort)
	Dim As String sTxt1,sTxt2
	Dim As Integer iCmp,valu1,valu2
	If pList = 0 Then
		Return 0
	EndIf

	pList->GetItemText( lParam1,pList->b_CurCol,sTxt1)
	pList->GetItemText( lParam2,pList->b_CurCol,sTxt2)
	
	If pList->b_UserSort = 1 Then					' String aufsteigend
		iCmp = lstrcmpi(StrPtr(sTxt1), StrPtr(sTxt2))
		If iCmp <> 0 Then
			Return iCmp
		EndIf
	ElseIf pList->b_UserSort = 2 then			' Zahlen aufsteigend
		valu1 =Val(sTxt1)
		valu2 =Val(sTxt2)
		iCmp = valu1- valu2
		If iCmp <> 0 Then
			Return iCmp
		EndIf
	ElseIf pList->b_UserSort = 3 Then			' String absteigend
		iCmp = lstrcmpi(StrPtr(sTxt2), StrPtr(sTxt1))
		If iCmp <> 0 Then
			Return iCmp
		EndIf
	ElseIf pList->b_UserSort = 4 Then			' Zahlen absteigend
		valu1 =Val(sTxt1)
		valu2 =Val(sTxt2)
		iCmp = valu2- valu1
		If iCmp <> 0 Then
			Return iCmp
		EndIf
	End If
End Function
Sub FListView.FixedItem
	Dim As LV_ITEM lvi    
	Dim As Integer lvInex
	
	For lvInex = 0 To this.RowCount -1
		lvi.mask =  LVIF_PARAM 
		lvi.iItem  = lvInex 
		lvi.lParam = lvInex 
		ListView_SetItem(this.Handle, @lvi)
	Next
End Sub
Sub FListView.GetHitedItem( ByVal lParam As LPARAM, ByRef nItem As integer, ByRef nSubItem As Integer)

  Dim LVHitTest As LVHITTESTINFO

  LVHitTest.pt.x = LOWORD(lParam)
  LVHitTest.pt.y = HIWORD(lParam)

  SendMessage( this.Handle, LVM_SUBITEMHITTEST, 0, CInt(@LVHitTest))

  nItem = LVHitTest.iItem
  nSubItem = LVHitTest.iSubItem

End Sub

Function FListView.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT  
   
  	Dim As Integer nItem , nSubItem
         	             
   Select case uMsg  
   	 
   	Case WM_PARENTNOTIFY  
   		If LOWORD(wParam) = WM_LBUTTONDOWN	Then
   			GetHitedItem(  lParam , nItem , nSubItem )
   			If this.onLButtondown Then this.onLButtondown(nItem , nSubItem)
   		EndIf
   	 	Return 0
 
   	Case WM_NOTIFY	
			Dim pNMSC AS NMHDR Ptr = Cast(Any Ptr, lParam)
			Dim zeile As Integer
			Dim szText As ZString * MAX_PATH
   		Dim sText As String 
   		
			Select Case pNMSC->code 
				Case NM_CLICK 
					Dim As NMLISTVIEW Ptr pnmv = Cast(Any Ptr, lParam)
					zeile = pnmv->iItem
					this.GetItemText( zeile , 0, sText)		
					If this.onClick Then	
						szText = sText
						this.onClick(zeile,szText)
						SetFocus(hWnd)
					End If
					Return 0
            '--------------------------------------------------------
				Case NM_RETURN	
					Dim As NMLISTVIEW Ptr pnmv = Cast(Any Ptr, lParam)
					zeile = pnmv->iItem
					this.GetItemText( zeile , 0, sText)		
					If this.onReturn Then	
						szText = sText
						this.onReturn(zeile,szText)
						SetFocus(hWnd)
					End If
					Return 0
				'--------------------------------------------------------
				Case NM_DBLCLK	
					Dim As NMLISTVIEW Ptr pnmv = Cast(Any Ptr, lParam)
					zeile = pnmv->iItem
					this.GetItemText( zeile , 0, sText)		
					If this.onDblClick Then	
						szText = sText
						this.onDblClick(zeile,szText)
						SetFocus(hWnd)
					End If
					Return 0
				'-------------------------------------------------------- 	
				Case LVN_COLUMNCLICK	
					Dim As NMLISTVIEW Ptr pnmv = Cast(Any Ptr, lParam)
					If this.onColumClick Then		
						this.onColumClick(pnmv->iSubItem)
					End If		
					If this.b_UserSort <> 0 Then	 ' 0 nein,  1 string aufsteigend, 2 string absteigend , 3 val aufsteigend, 4 val absteigend
 						this.b_CurCol = pnmv->iSubItem
 						this.AutoSort = 0 ' Autosort abschalten
						  ListView_SortItems(pnmv->hdr.hwndFrom,@FListView.SortierFunc ,CInt(@This))
						  FixedItem
					End If
					Return 0
					
				case LVN_ENDLABELEDIT
					Return EndLabelEdit( lParam )
			End select	   	 
   End Select 
   
   Function = DefWindowProc(hWnd,uMsg,wParam,lParam) 
End Function

Sub FListView.GetItemText( ByVal iItem As Integer, ByVal iSubItem As Integer,ByRef sText As String)
	Dim ms_lvi AS LV_ITEM
	Dim szText As ZString * MAX_PATH
	
	 ms_lvi.iSubItem = iSubItem
    ms_lvi.cchTextMax = MAX_PATH - 1
    ms_lvi.pszText = @szText
	
	SendMessage( this.Handle, LVM_GETITEMTEXT, iItem,CInt( @ms_lvi))
	sText = szText
End Sub
Sub FListView.Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	
   Dim lStyle AS UInteger
   Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst
 	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
   
   this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE OR WS_CHILD  , x, y, w , h , _
                          hParent , NULL, hInst , NULL )

   SetWindowLong(this.CtHandle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz

   IF this.CtHandle = 0 THEN
		MessageBox(0,"Fehler -> bei Create ListView ","Fehler",MB_ICONERROR)  
		Exit Sub
   END If
   
   this.Parent  = hParent
   this.Left    = x
	this.Top     = y
	this.Width   = w
	this.Height  = h
	
  	szClass 	= "SysListView32"
	this.Handle = CreateWindowEx( this.ExStyle , @szClass ,"" , this.Style , 0, 0, w, h , this.CtHandle ,NULL, hInst, NULL)
	
	lStyle = ListView_GetExtendedListViewStyle(this.Handle )
	ListView_SetExtendedListViewStyle(this.Handle, lStyle OR LVS_EX_FULLROWSELECT Or LVS_EX_GRIDLINES )  
	
   If this.Handle = 0 Then   	
   	MessageBox(0,"Fehler -> bei Create ListView ","Fehler",MB_ICONERROR)  
   EndIf 
   
End Sub
