'--------------------------------------------------------------------
' 											MenuItem
'--------------------------------------------------------------------

Dim Shared acc() AS ACCEL

Type FMenuItem Extends Object	
	
	Declare Property vKey As UShort
	Declare Property vKey( value As UShort)
	Declare Property sKey As String
	Declare Property sKey( value As String)
	Declare Property ctrKey As Integer
	Declare Property ctrKey(ByVal value As Integer)	
	Declare Property EventSub(ByVal value As Any Ptr)
	Declare Property EventSub As Any Ptr
	Declare Property MItemID As Integer	
	Declare Property MItemID(ByVal value As Integer)	
	Declare Property bmpUnCeck(value As String)
	Declare Property bmpCeck(value As String)
	Declare Property hbmUnCeck  As HBITMAP
	Declare Property hbmCeck  As HBITMAP
	Declare Property Check(ByVal value As Integer)
	Declare Property Check As Integer
	Declare Property Enabled(ByVal value As Integer)
	Declare Property Enabled As Integer
	Declare Sub addAccel(ByVal virt As Integer, ByVal  vK As UShort , sK As String)		
	Declare Constructor
	Declare Destructor
	
	hMenuBar		As HMENU
	
	Private:
	m_sKey		As String
	m_vKey		As UShort
	m_ctrKey		As Integer
	m_accel		As Integer
	m_Check		As Integer
	m_Enabled	As Integer
	m_EventSub 	As Any Ptr	
	m_MItemID 	As Integer
	m_bmpUnCeck	As HBITMAP
	m_bmpCeck	As HBITMAP
End Type

Constructor FMenuItem
	this.m_Check		= 0
	this.m_vKey			= 0
	this.m_ctrKey		= 0
	this.m_EventSub 	= 0
	this.m_bmpUnCeck	= 0
	this.m_bmpCeck		= 0
End Constructor
Destructor FMenuItem
	If this.m_bmpUnCeck Then
		DeleteObject(this.m_bmpUnCeck)
	EndIf
	If this.m_bmpCeck Then
		DeleteObject(this.m_bmpCeck)
	EndIf
End Destructor
Property FMenuItem.hbmUnCeck  As HBITMAP
	Return this.m_bmpUnCeck
End Property
Property FMenuItem.hbmCeck  As HBITMAP
	Return this.m_bmpCeck
End Property
Property FMenuItem.sKey As String
	Return this.m_sKey
End Property
Property FMenuItem.sKey( value As String)
	this.m_sKey = value
End Property
Property FMenuItem.vKey As UShort
	Return this.m_vKey
End Property
Property FMenuItem.vKey( value As UShort)
	this.m_vKey = value
End Property
Property FMenuItem.ctrKey As Integer
	Return this.m_ctrKey
End Property
Property FMenuItem.ctrKey(ByVal value As Integer)
	this.m_ctrKey = value
End Property
Property FMenuItem.bmpUnCeck( value As String)
	Dim As ZString * MAX_PATH szRes
	szRes = value
	If this.m_bmpUnCeck Then
		DeleteObject(this.m_bmpUnCeck)
	EndIf
	If InStr(szRes,".") = 0 Then  	' Wenn kein Punkt (.) enthalen ist, dann Resource 
		this.m_bmpUnCeck	= LoadBitmap(GetModuleHandle(0) , cast( LPCSTR, @szRes ))			
   Else										' mit Punkt (.) dann Deteiname
   	this.m_bmpUnCeck	= LoadImage(NULL,@szRes,IMAGE_Bitmap,0,0,LR_DEFAULTCOLOR Or LR_LOADFROMFILE )	
	End If
	If this.m_bmpUnCeck = 0 Then
			MessageBox( null, "Fehler - Bitmap ist nicht geladen", "Menu Error", MB_ICONERROR )
	EndIf  	
End Property
Property FMenuItem.bmpCeck( value As String)
	Dim As ZString * MAX_PATH szRes
	szRes = value
	If this.m_bmpCeck Then
		DeleteObject(this.m_bmpCeck)
	EndIf
	If InStr(szRes,".") = 0 Then  	' Wenn kein Punkt (.) enthalen ist, dann Resource 
		this.m_bmpCeck	= LoadBitmap(GetModuleHandle(0) , cast( LPCSTR, @szRes ))			
   Else										' mit Punkt (.) dann Deteiname
   	this.m_bmpCeck	= LoadImage(NULL,@szRes,IMAGE_Bitmap,0,0,LR_DEFAULTCOLOR Or LR_LOADFROMFILE )	
	End If
	If this.m_bmpCeck = 0 Then
			MessageBox( null, "Fehler - Bitmap ist nicht geladen", "Menu Error", MB_ICONERROR )
	EndIf  	
	
End Property
Property FMenuItem.Check(ByVal value As Integer)
	this.m_Check = IIf(value, MFS_CHECKED, MFS_UNCHECKED)
	If this.hMenuBar Then
		Dim As MENUITEMINFO mi
		Dim retval As Integer
		mi.cbSize 		= SizeOf(mi)
		mi.fMask  		= MIIM_CHECKMARKS Or MIIM_STATE	
		mi.hbmpChecked = this.m_bmpCeck
		mi.hbmpUnchecked = this.m_bmpUnCeck
		mi.fState = this.m_Check
		retval = SetMenuItemInfo(this.hMenuBar,this.MItemID,FALSE,@mi)	
	End If	
End Property

Property FMenuItem.Check As Integer
   Dim As Integer iRet
   If  this.m_Check = MFS_CHECKED Then
   	iRet = TRUE
   Else 
   	iRet = FALSE
   EndIf
	Return iRet
End Property
Property FMenuItem.Enabled(ByVal value As Integer)
	this.m_Enabled = IIf(value, MFS_ENABLED, MFS_DISABLED)	
	If this.hMenuBar Then
		Dim As MENUITEMINFO mi
		Dim retval As Integer
		mi.cbSize 	= SizeOf(mi)
		mi.fMask  	=  MIIM_STATE		
		mi.fState 	= this.m_Enabled
		retval = SetMenuItemInfo(this.hMenuBar,this.MItemID,FALSE,@mi)	
	End If	
End Property

Property FMenuItem.Enabled As Integer
	Dim As Integer iRet
   If  this.m_Check = MFS_ENABLED Then
   	iRet = TRUE
   Else 
   	iRet = FALSE
   EndIf
	Return iRet
End Property

Property FMenuItem.EventSub(ByVal value As Any Ptr)
	this.m_EventSub = value
End Property
Property FMenuItem.EventSub As Any Ptr
	Return this.m_EventSub 
End Property

Property FMenuItem.MItemID As Integer 
	Return this.m_MItemID
End Property
Property FMenuItem.MItemID(ByVal value As Integer) 
	this.m_MItemID = value
End Property

Sub FMenuItem.addAccel(ByVal virt As Integer,ByVal  vK As UShort , sK As String)		
		this.ctrKey = virt
		this.vKey	= vK	
		this.sKey	= sK	
End Sub
'--------------------------------------------------------------------
'					Das Menu
'--------------------------------------------------------------------
Type FMenu Extends Object	
	public: 
	Declare Sub Create(ByVal hParent As HWND)  
   Declare Sub CreateSubMenu(sName As String ) 
   Declare Sub AddItem(oItem As FMenuItem Ptr,sText As String)
   Declare Sub Seperator()
   Declare Constructor
   Declare Destructor   
   Declare Property Handle As HMENU
   Declare Property Parent As HWND 
   Declare Sub FMenuProc(ByVal wID As Integer)  
   
   Private:
   m_accel	As Integer
	m_Curpos As Integer
	m_Newpos	As Integer
   m_Handle As HMENU
   m_Parent As HWND
   m_ItemID As Integer
End Type
Constructor FMenu
	this.m_Handle 		= 0
   this.m_NewPos		= 0
   this.m_Curpos		= 0
   this.m_ItemID		= 1024
   this.m_accel		= -1
   this.m_Parent 		= 0
	this.m_Handle 		= 0
End Constructor
Destructor FMenu
	DestroyMenu(this.m_Handle)	
End Destructor
Property FMenu.Handle As HMENU
	Return this.m_Handle
End Property
Property FMenu.Parent As HWND
	Return this.m_Parent
End Property
Sub FMenu.Create(ByVal hParent As HWND) 
	this.m_Parent = hParent
	this.m_Handle = CreateMenu()
	SetMenu(hParent,this.m_Handle)
End Sub
Sub FMenu.CreateSubMenu(sName As String )
	Dim As ZString * 128 szText
	Dim As Integer er
	Dim As MENUITEMINFO mi
	
	this.m_Curpos = this.m_NewPos
	
	szText 	 	= sName
	mi.cbSize 	= SizeOf(mi)
	mi.fMask  	= MIIM_TYPE Or MIIM_SUBMENU 	
	mi.fType  	= MFT_STRING
	mi.hSubMenu = CreatePopupMenu()	
	mi.dwTypeData = @szText
	mi.cch 		= Len(szText)
		
	If InsertMenuItem(this.m_Handle,this.m_NewPos,TRUE,@mi) = 0 Then
		er = GetLastError
		MessageBox(0," Fehler SubMenu - Error Nr. = "+Str$(er),"info",MB_OK)
	EndIf
	this.m_NewPos = this.m_Curpos + 1    
End Sub
Sub FMenu.AddItem(oItem As FMenuItem Ptr,sText As String)
	
	Dim As ZString * 128 szText
	Dim As MENUITEMINFO mi
	Dim As HMENU hsubMenu
	Dim As string vK = ""
	
	oItem->hMenuBar = this.Handle
	
	hsubMenu = GetSubMenu(this.m_Handle,this.m_Curpos)
		
	If oItem->vKey > 0 Then		
		this.m_accel = this.m_accel + 1
		
		ReDim Preserve acc(this.m_accel)
		acc(this.m_accel).fVirt = oItem->ctrKey Or FVIRTKEY
		acc(this.m_accel).key	= oItem->vKey
		acc(this.m_accel).cmd	= this.m_ItemID
	
		If oItem->ctrKey = FSHIFT Then
			vK = "Shift+"
			sText = sText + Chr(9) + vK + oItem->sKey 
		ElseIf oItem->ctrKey	 = FCONTROL Then
			vK = "Ctrl+"
			sText = sText + Chr(9) + vK + oItem->sKey 
		ElseIf oItem->ctrKey	 = FALT Then
			vK = "Alt+"
			sText = sText + Chr(9) + vK + oItem->sKey 
		ElseIf oItem->ctrKey	 = 0 Then	
			sText = sText + Chr(9) + oItem->sKey 
		EndIf			
	EndIf
	oItem->MItemID = this.m_ItemID
   szText 			= sText
	mi.cbSize 		= SizeOf(mi)
	mi.fMask  		= MIIM_SUBMENU Or MIIM_TYPE Or MIIM_DATA	Or MIIM_ID Or MIIM_CHECKMARKS	Or MIIM_STATE	
	mi.fType  		= MFT_STRING
	mi.fState 		= oItem->Enabled	
	mi.hSubMenu		= 0
	mi.hbmpChecked = oItem->hbmCeck
	mi.hbmpUnchecked = oItem->hbmUnCeck
	mi.wID			= this.m_ItemID
	mi.dwItemData	= CInt(oItem->EventSub)
	mi.dwTypeData 	= @szText
	mi.cch 			= Len(szText)
	
	InsertMenuItem(hsubMenu,this.m_ItemID,FALSE,@mi)
   this.m_ItemID = this.m_ItemID + 1
   
End Sub
Sub FMenu.Seperator()
		
	Dim As MENUITEMINFO mi
	Dim As HMENU hsubMenu
	
	hsubMenu = GetSubMenu(this.Handle,this.m_Curpos)
	
	mi.cbSize 		= SizeOf(mi)
	mi.fMask  		= MIIM_SUBMENU Or MIIM_TYPE 
	mi.fType  		= MFT_SEPARATOR		
	mi.hSubMenu		= 0
	mi.wID			= 0
	mi.dwItemData	= 0
	mi.dwTypeData 	= 0
	mi.cch 			= 0
	
	InsertMenuItem(hsubMenu,-1,FALSE,@mi)
   
End Sub

Sub FMenu.FMenuProc(ByVal wID As Integer)  
	Dim onClick As Sub()
	Dim As MENUITEMINFO mi
	
	mi.cbSize 		= SizeOf(mi)
	mi.fMask  		= MIIM_DATA	Or MIIM_ID	
			
	GetMenuItemInfo(this.m_Handle,wID,FALSE,@mi)
	If mi.dwItemData Then
		onClick = Cast(Any Ptr,mi.dwItemData)
		onClick()
	EndIf
	
End Sub
'