
#Include Once "win\Richedit.bi"
'------------------------------------------------------------------------------------------
' Font erstellen-ndert - In RichEdit
'------------------------------------------------------------------------------------------
Type FFont Extends Object  	
  	Public:
	Declare Property FaceName() As String	
	Declare Property FaceName( face As String	) 				
	Declare Property Size( ByVal x As Integer )		
  	Declare Property Size() As Integer					
   Declare Property Bold( ByVal x As Integer )		
  	Declare Property Bold() As Integer				
  	Declare Property Italic( ByVal x As Integer )		
  	Declare Property Italic() As Integer				
  	Declare Property Underline( ByVal x As Integer )		
  	Declare Property Underline() As Integer	
  	Declare Property StrikeOut( ByVal x As Integer )		
  	Declare Property StrikeOut() As Integer	
  	Declare Property FontHandle() As HFONT					
  	Declare Constructor 
	Declare DESTRUCTOR  
	Private:
   f_FaceName 	As ZString * 32 
	f_Size 		As Integer	
	f_Bold 		As Integer
	f_Italic 	As Integer
	f_StrikeOut As Integer
	f_Underline As Integer
   f_Handle		As HFONT
End Type

Constructor FFont	
	this.f_Handle	 = GetStockObject(SYSTEM_FONT)
	this.f_FaceName = "System"
	this.f_Size  	 =	10
	this.f_Bold 	 = 0
	this.f_Italic 	 = 0
	this.f_StrikeOut = 0
	this.f_Underline = 0		
End Constructor

Destructor FFont ' OK
	DeleteObject(this.f_Handle)	
End Destructor

Property FFont.FontHandle() As HFONT
	Dim lgFont AS LOGFONT 
	lgFont.lfFaceName = this.f_FaceName
	lgFont.lfHeight 	= -MulDiv(this.f_Size, GetDeviceCaps(GetDC(0), LOGPIXELSY), 72)
	lgFont.lfWeight 	= IIf(this.f_Bold,800,400)
	lgFont.lfItalic 	= IIf(this.f_Italic,1,0)
	lgFont.lfStrikeOut = IIf(this.f_StrikeOut,1,0)
	lgFont.lfUnderline = IIf(this.f_Underline,1,0)
	If this.f_Handle Then
		DeleteObject(this.f_Handle)
	EndIf
	this.f_Handle = (CreateFontIndirect(@lgFont))
	Return this.f_Handle	
End Property
Property FFont.FaceName As String	
	Dim s As String
	s =this.f_FaceName
	Return s
End Property
Property FFont.FaceName( face As String	) 
	this.f_FaceName = face
End Property
				
Property FFont.Size( ByVal x As Integer )		
	this.f_Size = x
End Property
Property FFont.Size As Integer		
	Return this.f_Size
End Property
   
Property FFont.Bold( ByVal x As Integer )	
	this.f_Bold = x
End Property
Property FFont.Bold As Integer	
	Return this.f_Bold
End Property
  	
Property FFont.Italic( ByVal x As Integer )	
	this.f_Italic = x
End Property
Property FFont.Italic As Integer	
	Return this.f_Italic
End Property
  	
Property FFont.Underline( ByVal x As Integer )	
	this.f_Underline = x
End Property
Property FFont.Underline As Integer	
	Return this.f_Underline
End Property
  	
Property FFont.StrikeOut( ByVal x As Integer )	
	this.f_StrikeOut = x
End Property
Property FFont.StrikeOut As Integer	
	Return this.f_StrikeOut
End Property

'---------------------------------------------------------------------------------------------------------
' RichEdit
'--------------------------------------------------------------------------------------------------------- 

Type FRichEdit Extends Control	
	public:
	Declare Property PlainText(ByVal value As Integer)
	Declare Property PlainText As Integer
	Declare Property Paraleft(ByVal value As Integer)
   Declare Property Paraleft As Integer
	Declare Property Pararight(ByVal value As Integer)
   Declare Property Pararight As Integer
   Declare Property Paracenter(ByVal value As Integer)
   Declare Property Paracenter As Integer
	Declare Property Modifid As Integer
	Declare Property SelText As String
	Declare Property SelStart As Integer
	Declare Property SelStart(ByVal value As Integer)
	Declare Property SelLen As Integer
	Declare Property SelLen(ByVal value As Integer)
   Declare Property BKColor(ByVal value As UInteger)
   Declare Property BKColor As UInteger
	Declare Property ReadOnly As Integer
   Declare Property ReadOnly(ByVal value As Integer)
   Declare Property LMargin(ByVal value As Integer)   
   Declare Property LMargin As Integer
   Declare Property RMargin(ByVal value As Integer)   
   Declare Property RMargin As Integer
   Declare Property AutoHScroll(ByVal value As Integer)
   Declare Property AutoVScroll(ByVal value As Integer)
   Declare Property ScrollBars(ByVal value As Integer)		    
   Declare Property Border(ByVal value As Integer)
   Declare Property CurLine As Integer				' aktuelle Zeile (Base 0) 
   Declare Property LineCount As Integer			' anzahl Zeilen (Base 1)
   Declare Property TextLen As Integer
	Declare Property Text As String 
	Declare Property Text(sText As String )
   Declare Constructor
   Declare Destructor
   
   Declare Sub ClearAll 
   Declare Sub GlobalFontStyle()
   Declare Sub SelFontStyle()
   Declare Sub GetFontStyle()
   Declare Sub SelParaStyle()
   Declare Sub GetParaStyle()
   Declare Sub SaveFile(filename As String)   
	Declare Sub LoadFile(filename As String)
	
	Declare Sub Cut()
   Declare Sub Copy()
   Declare Sub Paste()
   Declare Sub Clear()
	      
   Declare Sub Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer)
   DECLARE  FUNCTION CtrlMsgFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
   
    As FFont font
     
   ' Events	
	onChange  As SUB()
	onSelChange As SUB()	
	OnKeyUp As Sub(nKey AS Integer,lKeyStatus As Integer)
	OnKeyDown As Sub(nKey AS Integer,lKeyStatus As Integer)
	onLbuttondown As Sub(ByVal x As Integer,ByVal y As Integer,ByVal flag As Integer)
	onLbuttonup As Sub(ByVal x As Integer,ByVal y As Integer,ByVal flag As Integer)
	onMousemove As Sub(ByVal x As Integer,ByVal y As Integer,ByVal flag As Integer)
	onRbuttondown As Sub(ByVal x As Integer,ByVal y As Integer,ByVal flag As Integer)
	
	Private: 
	DECLARE static FUNCTION EditSubClassFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT  
	DECLARE static Function DatenIn(BYVAL dwCookie As UInteger  ,BYVAL lpBuff AS BYTE PTR, BYVAL cb AS INTEGER, BYVAL pcb AS INTEGER PTR) AS UInteger
	DECLARE static Function DatenOut(BYVAL dwCookie AS UInteger,BYVAL lpBuff AS BYTE PTR, BYVAL cb AS INTEGER, BYVAL pcb AS INTEGER PTR) AS UInteger
	As String	b_Text		= ""
   As HBRUSH	b_Brush		= 0
   As UInteger b_oldProc	= 0
   As HANDLE   b_RichLib	= 0
   As Integer  b_ReadOnly  = 0
   As Integer  b_lmargin	= 0
   As Integer  b_rmargin	= 0
   As Integer  b_Scroll		= 0
   As UInteger b_bkColor	= &HFFFFFF
   As Integer  b_paraleft	= 1
   As Integer  b_pararight	= 0
   As Integer  b_paracenter= 0
   As Integer  b_plaintext	= FALSE
End Type
Constructor FRichEdit
	this.b_RichLib   = LoadLibrary("RICHED32.DLL")
  	this.Handle  	  = 0
  	this.Handle  = 0
  	this.Color   = &HFFFFFF
  	this.ExStyle = WS_EX_CLIENTEDGE 
	this.Style 	 = WS_CHILD OR WS_VISIBLE OR ES_MULTILINE Or ES_WANTRETURN OR WS_VSCROLL Or WS_HSCROLL OR _
						ES_AUTOVSCROLL Or ES_NOHIDESEL OR ES_DISABLENOSCROLL
end Constructor
Destructor FRichEdit	
	If this.b_Brush Then
		DeleteObject(this.b_Brush)
	EndIf	
	if this.b_RichLib Then
		FreeLibrary(this.b_RichLib)
	EndIf
	If this.Handle Then
		SetWindowLong(this.Handle, GWL_WNDPROC, this.b_oldProc)
	End If
	this.Handle = 0
End Destructor
Property FRichEdit.PlainText(ByVal value As Integer)
	b_plaintext = IIf(value,TRUE,FALSE)
End Property
Property FRichEdit.PlainText As Integer
	Return b_plaintext
End Property
Property FRichEdit.Paraleft(ByVal value As Integer)
	b_paraleft = value
	If value <> 0 Then
		b_pararight = 0
		b_paracenter = 0
	EndIf
End Property
Property FRichEdit.Paraleft As Integer
	Return b_paraleft
End Property
Property FRichEdit.Pararight(ByVal value As Integer)
	b_pararight = value
	If value <> 0 Then
		b_paraleft = 0
		b_paracenter = 0
	EndIf
End Property
Property FRichEdit.Pararight As Integer
	Return b_pararight
End Property
Property FRichEdit.Paracenter(ByVal value As Integer)
	b_paracenter = value
	If value <> 0 Then
		b_paraleft = 0
		b_pararight = 0
	EndIf
End Property
Property FRichEdit.Paracenter As Integer
	Return b_paracenter
End Property

Property FRichEdit.AutoHScroll(ByVal value As Integer)
	Dim style As UInteger
	If this.Handle Then
		style = GetWindowLong(this.Handle,GWL_STYLE)		
		If value Then
			style = style Or ES_AUTOHSCROLL 
		Else
			style = style And(not ES_AUTOHSCROLL)
		End If
		SetWindowLong(this.Handle,GWL_STYLE,style)
		SetWindowPos(this.Handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	EndIf
End Property
Property FRichEdit.AutoVScroll(ByVal value As Integer)
	Dim style As UInteger
	If this.Handle Then
		style = GetWindowLong(this.Handle,GWL_STYLE)		
		If value Then
			style = style Or ES_AUTOVSCROLL 
		Else
			style = style And(not ES_AUTOVSCROLL)
		End If
		SetWindowLong(this.Handle,GWL_STYLE,style)
		SetWindowPos(this.Handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	EndIf
End Property
   
Property FRichEdit.Modifid As Integer
	If this.Handle Then	
		Return SendMessage(this.Handle, EM_GETMODIFY , 0 ,0 )
	EndIf
End Property
Property FRichEdit.CurLine As Integer
	If this.Handle Then	
		Return SendMessage(this.Handle, EM_LINEFROMCHAR , -1 ,0 )
	EndIf
End Property
Property FRichEdit.LineCount As Integer
	If this.Handle Then	
		Return SendMessage(this.Handle, EM_GETLINECOUNT , 0 ,0 )
	EndIf
End Property
Property FRichEdit.SelText As String
	Dim As CHARRANGE cr
	Dim iLen As Integer
	Dim sTmp As String
	If this.Handle Then	
		SendMessage(this.Handle,EM_EXGETSEL,0,Cast(WPARAM,@cr))
		If cr.cpMin = cr.cpMax  Then
			sTmp =""
			Return sTmp
		EndIf
		If (cr.cpMin = 0) And (cr.cpMax = -1) Then
			iLen = GetWindowTextLength(this.Handle)
			sTmp = String(iLen + 2,Chr(0)) 
			SendMessage(this.Handle,EM_GETSELTEXT,0,Cast(WPARAM,StrPtr(sTmp))) 
			Return sTmp 
		EndIf
		iLen = cr.cpMax - cr.cpMin
		sTmp = String(iLen + 2,Chr(0)) 
		SendMessage(this.Handle,EM_GETSELTEXT,0,Cast(WPARAM,StrPtr(sTmp))) 
		Return sTmp
	EndIf
End Property
Property FRichEdit.SelStart(ByVal value As Integer)
	Dim As CHARRANGE cr
	If this.Handle Then	
		cr.cpMin = value
		cr.cpMax = value
		SendMessage(this.Handle,EM_EXSETSEL,0,Cast(WPARAM,@cr))
	EndIf
End Property
Property FRichEdit.SelStart As Integer
	Dim As CHARRANGE cr
	Dim As Integer iRet
	If this.Handle Then		
		SendMessage(this.Handle,EM_EXGETSEL,0,Cast(WPARAM,@cr))
		iRet = cr.cpMin
		Return iRet
	EndIf
End Property
Property FRichEdit.SelLen(ByVal value As Integer)
	Dim As CHARRANGE cr
	If this.Handle Then			
		SendMessage(this.Handle,EM_EXGETSEL,0,Cast(WPARAM,@cr))
		cr.cpMax = cr.cpMin + value
		SendMessage(this.Handle,EM_EXSETSEL,0,Cast(WPARAM,@cr))
	EndIf
End Property
Property FRichEdit.SelLen As Integer
	Dim As CHARRANGE cr
	Dim As Integer iRet
	If this.Handle Then			
		SendMessage(this.Handle,EM_EXGETSEL,0,Cast(WPARAM,@cr))
		If cr.cpMin = cr.cpMax  Then
			Return 0
		EndIf
		If (cr.cpMin = 0) And (cr.cpMax = -1) Then
			Return GetWindowTextLength(this.Handle) 
		EndIf
		iRet = cr.cpMax - cr.cpMin
		Return iRet
	EndIf
End Property
Property FRichEdit.BKColor As UInteger
	Return this.b_bkColor
End Property
Property FRichEdit.BKColor(ByVal value As UInteger)
	If this.Handle Then	
		this.b_bkColor = value
		SendMessage(this.Handle,EM_SETBKGNDCOLOR,0,value) 
		this.repaint
	EndIf	
End Property

Property FRichEdit.Border(ByVal Value As Integer)
	Dim Styl As UInteger
	If this.Handle Then	
		Styl = GetWindowLong(this.Handle,GWL_STYLE)
		Select Case value
			Case 0				' Ohne
				If Styl And WS_BORDER Then
					this.Style = Styl And (Not WS_BORDER)
				EndIf
				this.ExStyle  = 0
			Case 1				' Sunken
				If Styl And WS_BORDER Then
					this.Style = Styl And (Not WS_BORDER)
				EndIf
				this.ExStyle  = WS_EX_CLIENTEDGE
			Case 2				' Border
				this.Style = Styl or WS_BORDER
				this.ExStyle  = 0
		End Select
		SetWindowLong(this.Handle,GWL_STYLE,this.Style)
		SetWindowLong(this.Handle,GWL_EXSTYLE,this.ExStyle)
		SetWindowPos(this.Handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	EndIf	
End Property
Property FRichEdit.RMargin(ByVal value As Integer)
	Dim As RECT rc
	If this.Handle Then
		this.b_rmargin = value
		SendMessage(this.Handle,EM_GETRECT , 0 , Cast(WPARAM,@rc)) 
		rc.right = rc.right - value - 1
		SendMessage(this.Handle,EM_SETRECT  , 0 , Cast(WPARAM,@rc)) 
	End If
End Property
Property FRichEdit.RMargin As Integer
	Dim As RECT rc
	If this.Handle Then
		SendMessage(this.Handle,EM_GETRECT  , 0 ,Cast(WPARAM,@rc)) 
		Return this.ClientWidth-rc.right
	End If
End Property

Property FRichEdit.LMargin(ByVal value As Integer)
	Dim As RECT rc
	If this.Handle Then
		this.b_lmargin = value
		SendMessage(this.Handle,EM_GETRECT , 0 , Cast(WPARAM,@rc)) 
		rc.left = rc.left + value
		SendMessage(this.Handle,EM_SETRECT  , 0 , Cast(WPARAM,@rc)) 
	End If
End Property
Property FRichEdit.LMargin As Integer
	Dim As RECT rc
	If this.Handle Then
		SendMessage(this.Handle,EM_GETRECT  , 0 ,Cast(WPARAM,@rc)) 
		Return rc.left
	End If
End Property
Property FRichEdit.ReadOnly As Integer
	If this.Handle Then
		Return this.b_ReadOnly
   End If
End Property
Property FRichEdit.ReadOnly(ByVal value As Integer)
	If this.Handle Then
		If value = 0 Then
			this.b_ReadOnly = 0
		 	SendMessage(this.Handle, EM_SETREADONLY,FALSE,0) 
		Else	
			this.b_ReadOnly = 1
			SendMessage(this.Handle, EM_SETREADONLY,TRUE,0)  
		EndIf	
   End If
End Property
Property FRichEdit.ScrollBars(ByVal value As Integer)
	Dim style As UInteger
	If this.Handle Then
		this.b_Scroll = value
		style = GetWindowLong(this.Handle,GWL_STYLE)		
		If this.b_Scroll Then
			style = style Or WS_HSCROLL Or WS_VSCROLL
		Else
			style = style And(not WS_HSCROLL)
			style = style And(not WS_VSCROLL)
		End If
		SetWindowLong(this.Handle,GWL_STYLE,style)
		SetWindowPos(this.Handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	EndIf
End Property

Property FRichEdit.TextLen As Integer
	If this.Handle Then
		Return GetWindowTextLength(this.Handle) 
	EndIf
End Property
Property FRichEdit.Text As String 	
	If this.Handle Then	
		Dim  As Integer maxCount,i
		maxCount = GetWindowTextLength(this.Handle) 
		this.b_Text = String(maxCount+2,Chr(0))  
		i = GetWindowText(this.Handle , StrPtr(this.b_Text) , maxCount+1 )	
		Return this.b_Text
	EndIf
End Property
Property FRichEdit.Text(sText As String )
	If this.Handle Then
		this.b_Text = sText
		SetWindowText(this.Handle ,sText)		
	EndIf
End Property
Sub FRichEdit.Cut()
	If this.Handle Then
		SendMessage(this.Handle,WM_CUT,0,0)
	EndIf
End Sub
Sub FRichEdit.Copy()
	If this.Handle Then
		SendMessage(this.Handle,WM_COPY,0,0)
	EndIf
End Sub
Sub FRichEdit.Paste()
	If this.Handle Then
		SendMessage(this.Handle,WM_PASTE,0,0)
	EndIf
End Sub
Sub FRichEdit.Clear()
	If this.Handle Then
		SendMessage(this.Handle,WM_CLEAR,0,0)
	EndIf
End Sub
Sub FRichEdit.ClearAll
	If this.Handle Then
		Dim As CHARRANGE cr
		cr.cpMin = 0
		cr.cpMax = -1
		SendMessage(this.Handle,EM_EXSETSEL,0,Cast(WPARAM,@cr))
		SendMessage(this.Handle, WM_CLEAR, 0, 0)
	EndIf
End Sub
Sub FRichEdit.SelParaStyle()
	 Dim pf    AS PARAFORMAT

   pf.cbSize = SizeOf(pf)
   pf.dwMask = PFM_ALIGNMENT  
	If this.b_paraleft = TRUE Then
			pf.wAlignment= PFA_LEFT
			SendMessage(this.Handle,EM_SETPARAFORMAT,0,Cast(WPARAM, (@pf))) 
			Exit Sub
	ElseIf this.b_paracenter = TRUE Then
			pf.wAlignment= PFA_CENTER
			SendMessage(this.Handle,EM_SETPARAFORMAT,0,Cast(WPARAM, (@pf))) 
			Exit Sub
	ElseIf this.b_pararight = TRUE Then		
			pf.wAlignment= PFA_RIGHT
			SendMessage(this.Handle,EM_SETPARAFORMAT,0,Cast(WPARAM, (@pf))) 
			Exit Sub			
	Else
			pf.wAlignment= PFA_LEFT
			 SendMessage(this.Handle,EM_SETPARAFORMAT,0,Cast(WPARAM, (@pf))) 
	 End If 
End Sub
Sub FRichEdit.GetParaStyle()
	 Dim pf    AS PARAFORMAT

    
    pf.cbSize = SizeOf(pf)
    pf.dwMask = PFM_ALIGNMENT

    IF SendMessage(this.Handle,EM_GETPARAFORMAT,0,Cast(WPARAM, @pf)) = 0 THEN
          MessageBox(0, " GetParaFormat - Fehler","Fehler",MB_ICONERROR)
           EXIT SUB
    END IF
    ' links
    IF pf.wAlignment = PFA_LEFT THEN
      this.b_paraleft = TRUE
      this.b_paracenter = FALSE
      this.b_pararight = FALSE  
    END IF
    'mitte
    IF pf.wAlignment = PFA_CENTER THEN
      this.b_paraleft = FALSE 
      this.b_paracenter = TRUE
      this.b_pararight = FALSE  
    END IF
    ' rechts
    IF pf.wAlignment = PFA_RIGHT THEN
      this.b_paraleft = FALSE 
      this.b_paracenter = FALSE
      this.b_pararight = TRUE   
    END If
End Sub
Sub FRichEdit.SelFontStyle()
	
	Dim AS CHARFORMAT cf
	Dim As uInteger retVal
	cf.cbSize = SizeOf(cf)
	cf.dwMask = CFM_COLOR OR CFM_FACE OR CFM_SIZE OR CFM_BOLD OR CFM_ITALIC OR CFM_UNDERLINE Or CFM_STRIKEOUT	
	
	cf.szFaceName  = this.font.FaceName
	cf.yHeight     = Abs(this.font.Size * 20)
	cf.crTextColor = this.TextColor
	
	retVal = 0
	If this.font.Bold Then retVal  = retVal Or CFE_BOLD
	If this.font.Italic Then retVal  = retVal Or CFE_ITALIC	
	If this.font.Underline Then retVal  = retVal Or CFE_UNDERLINE
	If this.font.StrikeOut Then retVal  = retVal Or CFE_STRIKEOUT
	
	cf.dwEffects  = retVal
	
 	retVal=SendMessage(this.Handle,EM_SETCHARFORMAT,SCF_SELECTION	,Cast(WPARAM, @cf)) 
   If retVal = 0 Then	
      MessageBox(0, " SetChar All - Fehler " + Hex(cf.dwMask),"Fehler",MB_ICONERROR)
   End If
   
End Sub
Sub FRichEdit.GetFontStyle()
	 Dim cf    AS CHARFORMAT
   
    cf.cbSize = SizeOf(cf)
    cf.dwMask = CFM_COLOR OR CFM_FACE OR CFM_SIZE OR CFM_BOLD OR CFM_ITALIC OR CFM_UNDERLINE Or CFM_STRIKEOUT

    IF SendMessage(this.Handle,EM_GETCHARFORMAT,SCF_SELECTION,Cast(WPARAM, @cf)) = 0 Then
            MessageBox(0, " GetChar All - Fehler " + Hex(cf.dwMask),"Fehler",MB_ICONERROR)
    END IF
     this.font.FaceName  	= cf.szFaceName
     this.font.Size 			=  ABS(cf.yHeight/20)' Die Schrifthhe wird in Twips zurck gegeben !
     this.TextColor 	 		=  cf.crTextColor
     this.font.Bold   		=  cf.dwEffects AND CFE_BOLD
     this.font.Italic 		=  cf.dwEffects AND CFE_ITALIC
     this.font.Underline 	=  cf.dwEffects AND CFE_UNDERLINE
     this.font.Strikeout 	=  cf.dwEffects AND CFM_STRIKEOUT
     
End Sub
Sub FRichEdit.GlobalFontStyle()
	
	Dim AS CHARFORMAT cf
	Dim As Integer retVal
	cf.cbSize = SizeOf(cf)
	cf.dwMask = CFM_COLOR OR CFM_FACE OR CFM_SIZE
	
	cf.szFaceName  = this.font.FaceName
	cf.yHeight     = -MulDiv(this.font.Size, GetDeviceCaps(GetDC(0), LOGPIXELSY), 72)
	cf.crTextColor = this.TextColor
	cf.dwEffects   = 0
	
	SendMessage(this.Handle,WM_SETFONT,Cast(Uinteger, this.font.FontHandle),TRUE)
	
 	retVal=SendMessage(this.Handle,EM_SETCHARFORMAT,SCF_DEFAULT,Cast(WPARAM, @cf)) 
   If retVal = 0 Then	
      MessageBox(0, " SetChar All - Fehler " + Hex(cf.dwMask),"Fehler",MB_ICONERROR)
   End If
   
End Sub
 '----------------------- RTF-Datei-Load Callback Function --------------------
FUNCTION FRichEdit.DatenIn(BYVAL dwCookie AS UInteger,BYVAL lpBuff AS BYTE PTR, _
                 BYVAL cb AS INTEGER, BYVAL pcb AS INTEGER PTR) AS UInteger

      Dim nResult AS UInteger
      nResult =ReadFile( Cast(Any Ptr, dwCookie), lpBuff, cb, pcb, BYVAL NULL)
      IF nResult = 0 THEN
         FUNCTION=TRUE
         EXIT FUNCTION
      END IF

      FUNCTION = FALSE
 END Function
 '----------------------- RTF-Datei-Save Callback Function --------------------- 
FUNCTION FRichEdit.DatenOut(BYVAL dwCookie AS UInteger,BYVAL lpBuff AS BYTE PTR, _
                 BYVAL cb AS INTEGER, BYVAL pcb AS INTEGER PTR) AS UInteger

      Dim nResult AS UInteger
      nResult =WriteFile(Cast(Any Ptr, dwCookie),lpBuff, cb, pcb, BYVAL NULL)
      IF nResult = 0 THEN
         FUNCTION=TRUE
         EXIT FUNCTION
      END IF

      FUNCTION = FALSE
 END FUNCTION
 '--------------------------------- Datei Laden -------------------------------
 SUB FRichEdit.LoadFile(filename As String)  
      DIM hFile    AS HANDLE
      Dim es       AS EDITSTREAM
      Dim lpStream AS EDITSTREAM Ptr
    
       IF LEN(filename)>4 Then
         hFile = CreateFile(StrPtr(filename) ,GENERIC_READ, 0 , 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)
			
         es.dwCookie = Cast(UInteger, hFile)
         es.pfnCallback = Cast(EDITSTREAMCALLBACK, @DatenIn)
         lpStream = @es

         IF this.PlainText = FALSE Then
         	SendMessage(this.Handle,EM_STREAMIN,SF_RTF,Cast(WPARAM, lpStream))
         ELSE
         	SendMessage(this.Handle,EM_STREAMIN,SF_TEXT,Cast(WPARAM, lpStream))
         END If
         CloseHandle(hFile)
         
      END IF
 END SUB
'---------------------------------------------------------------------------------------
SUB FRichEdit.SaveFile(filename As String)   

      DIM hFile    AS HANDLE
      Dim es       AS EDITSTREAM
      Dim lpStream AS EDITSTREAM Ptr
     
     
      IF LEN(filename)>4 THEN
         hFile = CreateFile(StrPtr(filename),GENERIC_WRITE, 0,  0 , CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL ,  0)
         
         es.dwCookie = Cast(UInteger, hFile)
         es.pfnCallback = Cast(EDITSTREAMCALLBACK, @DatenOut)
         lpStream = @es

         IF this.PlainText = FALSE Then
         	SendMessage(this.Handle,EM_STREAMOUT ,SF_RTF,Cast(WPARAM, lpStream))
         ELSE
         	SendMessage(this.Handle,EM_STREAMOUT ,SF_TEXT,Cast(WPARAM, lpStream))
         END If
         CloseHandle(hFile)
      END IF
 END Sub

Function FRichEdit.EditSubClassFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
	
	Function = 0
	Dim As Integer lKeyDat = 0
	
	Dim as FRichEdit ptr Edit = cast(FRichEdit Ptr,GetWindowLong(hWnd,GWL_USERDATA)) ' Zeiger auf diese Klasse
	
	If Edit = 0 Then
		function = DefWindowProc(  hWnd, uMsg, wParam, lParam) 
		Exit Function
	EndIf
	
	Select case uMsg 				
		Case WM_GETDLGCODE  
   		Function = DLGC_WANTALLKEYS	
			Exit Function	
			'------------------------- 	
   	Case WM_RBUTTONDOWN
   		If Edit->onRbuttondown Then
         	Edit->onRbuttondown(LOWORD(lParam),HIWORD(lParam),wParam)
   		End If	
    		function = CallWindowProc( Cast(Any Ptr,Edit->b_oldProc), hWnd, uMsg, wParam, lParam) 
   		Exit Function	
   		'------------------------- 			
   	Case WM_LBUTTONDOWN
   		If Edit->onLbuttondown Then
         	Edit->onLbuttondown(LOWORD(lParam),HIWORD(lParam),wParam)
   		End If	
    		function = CallWindowProc( Cast(Any Ptr,Edit->b_oldProc), hWnd, uMsg, wParam, lParam) 
   		Exit Function	
   		'------------------------- 
   	Case WM_LBUTTONUP 
   		If Edit->onLbuttonup Then
         	Edit->onLbuttonup(LOWORD(lParam),HIWORD(lParam),wParam)
   		End If	
			function = CallWindowProc( Cast(Any Ptr,Edit->b_oldProc), hWnd, uMsg, wParam, lParam) 
   		Exit Function	
   		'------------------------- 
   	Case WM_MOUSEMOVE
   		If Edit->onMousemove Then
         	Edit->onMousemove(LOWORD(lParam),HIWORD(lParam),wParam) 
   		End If	 
   		function = CallWindowProc( Cast(Any Ptr,Edit->b_oldProc), hWnd, uMsg, wParam, lParam) 
   		Exit Function	
   		'------------------------- 	
		Case WM_KEYDOWN			
			If GetKeyState(VK_SHIFT) < -126 Then
				lKeyDat = VK_SHIFT	'&H10
			ElseIf GetKeyState(VK_CONTROL) < -126 Then	
				lKeyDat = VK_CONTROL	'&H11
			ElseIf GetKeyState(VK_MENU) < -126 Then		
				lKeyDat = VK_MENU		'&H12
			End If	
				
   		If Edit->OnKeyDown Then Edit->OnKeyDown(wParam,lKeyDat)	
   		SetFocus(hWnd) 
   		function = CallWindowProc( Cast(Any Ptr,Edit->b_oldProc), hWnd, uMsg, wParam, lParam) 
   		Exit Function	
   		
		Case WM_KEYUP			
			If GetKeyState(VK_SHIFT) < -126 Then
				lKeyDat = VK_SHIFT	'&H10
			ElseIf GetKeyState(VK_CONTROL) < -126 Then	
				lKeyDat = VK_CONTROL	'&H11
			ElseIf GetKeyState(VK_MENU) < -126 Then		
				lKeyDat = VK_MENU		'&H12
			End If	
				
   		If Edit->OnKeyUp Then Edit->OnKeyUp(wParam,lKeyDat)	
   		SetFocus(hWnd) 
   		function = CallWindowProc( Cast(Any Ptr,Edit->b_oldProc), hWnd, uMsg, wParam, lParam) 
   		Exit Function		  	
	End Select
	
	function = CallWindowProc( Cast(Any Ptr,Edit->b_oldProc), hWnd, uMsg, wParam, lParam) 
End Function
Function FRichEdit.CtrlMsgFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
     	        	   
   SELECT CASE uMsg
        CASE WM_ENABLE
         this.Enabled = wParam
         EXIT FUNCTION

        CASE WM_SETFONT,WM_SETTEXT
         IF this.Handle THEN
             FUNCTION = SendMessage(this.Handle,uMsg,wParam,lParam)
         END IF
         EXIT FUNCTION

        CASE WM_SIZE
         IF this.Handle THEN
             MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
         END IF
         EXIT FUNCTION          
   	
   	Case WM_NOTIFY 
	      Dim As NMHDR Ptr lpNMH = Cast(Any Ptr, lParam)
	      IF lpNMH->code = EN_SELCHANGE THEN        '
              GetParaStyle
              GetFontStyle
              If this.onSelChange Then
              	 this.onSelChange()
              EndIf
              SetFocus(this.Handle)
              Function = 0
   			 Exit Function
	      END If	
	      
   	Case  WM_COMMAND    		
   		If HiWord(wParam) = EN_CHANGE Then 
   			If this.onChange Then onChange() 	
   			Function = 0
   			Exit Function
   		End If
   		If HiWord(wParam) = EN_UPDATE  Then 
   			 	'
   			Function = 0
   			Exit Function
   		End If
   		
   End Select 
   
   function = DefWindowProc(  hWnd, uMsg, wParam, lParam)  
end Function

Sub FRichEdit.Create(ByVal hParent As HWND,ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	      
   
   DIM AS ZString * 32 szClass
   DIM AS HINSTANCE hInst

   szClass     = "FB_CONTROL"
   hInst        = GetModuleHandle(0)

   this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE OR WS_CHILD  , x, y, w , h , _
                          hParent , NULL, hInst , NULL )

   SetWindowLong(this.CtHandle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz

   IF this.CtHandle  THEN
        this.Left    = x
        this.Top     = y
        this.Width   = w
        this.Height  = h
        this.Parent  = hParent
   ELSE
        MessageBox(0,"Fehler - Create EDIT","Fehler",MB_ICONERROR)
        EXIT SUB
   END IF
	
	
	
   this.Handle = CreateWindowEx( this.ExStyle ,"RICHEDIT" , "" , this.Style  , 0, 0, w, h , this.CtHandle , NULL, hInst , NULL )
   IF this.Handle = 0 THEN
        MessageBox(0,"Fehler - Create EDIT","Fehler",MB_ICONERROR)
        Exit Sub
   EndIf  
	this.b_oldProc = SetWindowLong( this.Handle, GWL_WNDPROC, CInt(@FRichEdit.EditSubClassFunc))
	SetWindowLong(this.Handle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz
   ShowWindow(this.Handle,SW_SHOW)
   SendMessage(this.Handle,EM_SETEVENTMASK,0,Cast( WPARAM,ENM_SELCHANGE))
   
End Sub
