'--------------------------------------------------------------------
' UPDOWN
'--------------------------------------------------------------------
Type FUpDown Extends Control	
	public: 	
	Declare Property Upper(ByVal value As Short)
	Declare Property Upper As Short
	Declare Property Lower(ByVal value As Short)
	Declare Property Lower As Short
	Declare Property Curpos(ByVal value As Short)
	Declare Property Curpos As Short
	Declare Property Buddy(ByVal value As HWND)
	Declare Property Buddy As HWND
	Declare sub Range(ByVal min As  USHORT ,ByVal max As  USHORT )	    
   Declare Sub Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Constructor
   Declare Destructor  
   ' Events
   onChange As Sub(ByVal nPos As Integer)	
   ' Func
   Declare  Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT  
   Private:
   As HWND b_hBuddy 	= 0
   As Short b_UP 	= 10
   As Short b_LO	= 0
   As Short b_POS	= 0

End Type
Constructor FUpDown	
	
	If InitCommon = 0 Then 
		InitCommonControls
		InitCommon = 1
	EndIf
	
  	this.Handle  = 0
  	this.ExStyle = 0	
	this.Style 	 =  WS_CHILD Or WS_VISIBLE 
end Constructor

Destructor FUpDown
   this.Handle  = 0
End Destructor

Property FUpDown.Upper(ByVal value As Short)
	If this.Handle Then
		this.b_UP = value
		SendMessage(this.Handle,UDM_SETRANGE,0,MAKELONG(this.b_UP, this.b_LO))
	EndIf
End Property
Property FUpDown.Upper As Short
	Dim As UInteger nRange
	If this.Handle Then
		nRange = SendMessage(this.Handle,UDM_GETRANGE,0,0)
		this.b_UP = LoWord(nRange)
	EndIf
	Return this.b_UP
End Property
Property FUpDown.Lower(ByVal value As Short)
	If this.Handle Then
		this.b_LO = value
		SendMessage(this.Handle,UDM_SETRANGE,0,MAKELONG(this.b_UP, this.b_LO))
	EndIf
End Property
Property FUpDown.Lower As Short
	Dim As UInteger nRange
	If this.Handle Then
		nRange = SendMessage(this.Handle,UDM_GETRANGE,0,0)
		this.b_LO = HiWord(nRange)
	EndIf
	Return this.b_LO
End Property
Property FUpDown.Curpos(ByVal value As Short)
	Dim zTxt As ZString * 16
	If this.Handle Then
		this.b_POS = value
		SendMessage(this.Handle,UDM_SETPOS ,0,MAKELONG(value, 0))
		If this.b_hBuddy Then
			zTxt = Str(value)
			SetWindowText(this.b_hBuddy,@zTxt)
		EndIf
	EndIf
End Property
Property FUpDown.Curpos As Short
	If this.Handle Then
		this.b_POS = SendMessage(this.Handle,UDM_GETPOS,0,0)
	EndIf
	Return this.b_POS
End Property
Property FUpDown.Buddy(ByVal value As HWND)
	Dim zTxt As ZString * 16
	If this.Handle Then
		this.b_hBuddy = value
		SendMessage(this.Handle,UDM_SETBUDDY,Cast(WPARAM, value),0)
		zTxt = Str(this.Curpos)
		SendMessage(this.Buddy,WM_SETTEXT,0,CInt(@zTxt))
	EndIf
End Property
Property FUpDown.Buddy As HWND
	Return this.b_hBuddy
End Property
sub FUpDown.Range(ByVal min As  USHORT ,ByVal max As  USHORT )	
	If this.Handle Then
		this.b_LO = min
		this.b_UP = max
		SendMessage(this.Handle,UDM_SETRANGE,0,MAKELONG(this.b_UP, this.b_LO))
	EndIf
End Sub
Function FUpDown.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
	
	Dim zTxt As ZString * 16
	Dim As RECT rc
	
   Function = 0 
  
   Select case uMsg   	
    	Case WM_ENABLE 
   		this.Enabled = wParam
   		Exit Function
   		
   	Case WM_SIZE
         IF this.Handle THEN
             MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
         END IF
         EXIT Function
         
      Case WM_ERASEBKGND 
         Dim As RECT rc
         GetClientRect(hWnd,@rc)
         FillRect(Cast(HDC,wParam),@rc,GetStockObject(NULL_BRUSH))
         Function = TRUE
         Exit Function
            	
   	Case WM_HSCROLL  		
   		Select Case LoWord(wParam)
   			Case SB_THUMBPOSITION  		
		   		If this.onChange Then onChange(HIWORD(wParam))
		   		If this.Buddy Then
		   			zTxt = Str(HIWORD(wParam))
		   			SendMessage(this.Buddy,WM_SETTEXT,0,CInt(@zTxt))
		   		EndIf
		   		Exit Function
   		End Select
      		
   	Case  WM_VSCROLL	
   		Select Case LoWord(wParam)
   			Case SB_THUMBPOSITION  		
		   		If this.onChange Then onChange(HIWORD(wParam))
		   		If this.Buddy Then
		   			zTxt = Str(HIWORD(wParam))
		   			SendMessage(this.Buddy,WM_SETTEXT,0,CInt(@zTxt))
		   		EndIf
		   		Exit Function
   		End Select
   End Select
  
   Function = DefWindowProc(hWnd,uMsg,wParam,lParam)
end Function
'
Sub FUpDown.Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	
   Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst
 	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
   
    this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE OR WS_CHILD  , x, y, w , h , _
                          hParent , NULL, hInst , NULL )

   SetWindowLong(this.CtHandle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz

   IF this.CtHandle  THEN
        this.Left    = x
        this.Top     = y
        this.Width   = w
        this.Height  = h
        this.Parent  = hParent
   ELSE
        MessageBox(0,"Fehler - Create UPDOWN","Fehler",MB_ICONERROR)
        EXIT SUB
   END If
   
   szClass =  "msctls_updown32"
         
   this.Handle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE OR WS_CHILD  , 0, 0, w , h , _
                          this.CtHandle , NULL, hInst , NULL )                                               
  
   If this.Handle = 0  Then
   	MessageBox(0,"Fehler - Create UPDOWN","Fehler",MB_ICONERROR)
   End If
  
End Sub
