
#Include "winFBgui.bi "			


Dim Shared As FForm form1
Dim Shared As FPanel panel1,panel2
Dim Shared As FToolBtn tbBold,tbItalic,tbUnder,tbleft,tbcenter,tbright,tbColor,tbOpen,tbNeu
Dim Shared As FRichEdit REdit
Dim Shared As FCombobox combo1,combo2
Dim Shared As FOpenFile fopen
Dim Shared As FSaveFile	fsave
Dim Shared As FGroupbox	line1,line2,line3 ' als Line darstellen

' Sub und Functionen
#Include "RichUtil.bi"			


'--------------------------------------------------------------------
'                  Form   
'--------------------------------------------------------------------
form1.Create("RichEditControl",0,0,870,720)
Form1.Center
Form1.onSize = @Form1_onSize					' Controls Positionen 

'
'----------------Menu -----------------------------------------------
'
Dim As FMenuItem mnNeu,mnOpen,mnSaveAs ,mnExit	' Die Menu-Item
Dim As FMenuItem mnCopy,mnCut,mnPaste,mnDel		' Die Menu-Item

form1.menu.Create(form1.Handle)    		' Das Menu  			
form1.menu.CreateSubMenu("Datei")		' Das erste Popup

mnNeu.EventSub =@menu_neu					' Event-Sub
mnNeu.addAccel(NULL ,113,"F2" )			' nur F2	
form1.menu.AddItem(@mnNeu,"Neu")			' Zeiger auf das Item, Menu Text 

mnOpen.EventSub =@menu_Open
mnOpen.addAccel(FCONTROL ,Asc("O"),"O" )' Accel dazu,  STRG	CHR(255, 56)			
form1.menu.AddItem(@mnOpen,"Open")

mnSaveAs.EventSub =@menu_mnSaveAs	
mnSaveAs.addAccel(FCONTROL,Asc("S"),"S")' Accel dazu,  STRG,		
form1.menu.AddItem(@mnSaveAs,"SaveAs")

mnExit.EventSub =@menu_Exit				' Event-Sub
mnExit.addAccel(FCONTROL,Asc("Q"),"Q")	' Accel dazu,  STRG
form1.menu.AddItem(@mnExit,"Exit")		' Zeiger auf das Item, Menu Text 

form1.menu.CreateSubMenu("Bearbeiten")

mnCopy.EventSub =@menu_Copy
mnCopy.addAccel(FCONTROL,Asc("C"),"C")
form1.menu.AddItem(@mnCopy,"Kopieren")		' Zeiger auf das Item, Menu Text 

mnCut.EventSub =@menu_Cut	
mnCut.addAccel(FCONTROL,Asc("X"),"X")
form1.menu.AddItem(@mnCut,"Ausschneiden")		' Zeiger auf das Item, Menu Text 

mnPaste.EventSub =@menu_Paste
mnPaste.addAccel(FCONTROL,Asc("V"),"V")
form1.menu.AddItem(@mnPaste,"Einfgen")		' Zeiger auf das Item, Menu Text 

mnDel.EventSub =@menu_Del
mnDel.addAccel(NULL,VK_DELETE,"Entf")
form1.menu.AddItem(@mnDel,"Lschen")		' Zeiger auf das Item, Menu Text 

'-------------- Panel 1 als Toolbar     ----------------------------- 
panel1.Create(form1.Handle,0,0,864,34)
panel1.Border = 0
Panel1.Color=BGR(180,200,255)

panel2.Create(form1.Handle,0,671,864,26)
panel2.Border = 1
panel2.TextAlign = 0
panel2.Caption = "NoFile"

REdit.Create(Form1.Handle,0,36,866,636)
REdit.Border = 1
REdit.LMargin = 5 ' Linker Rand in Pixel


REdit.onSelChange = @REdit_SelChange

tbNeu.Create(panel1.Handle,2,2,30,30 )
tbNeu.Color=BGR(180,200,255)
tbNeu.Image(".\img\neu.png")
tbNeu.onClick = @menu_neu	

tbOpen.Create(panel1.Handle,34,2,30,30 )
tbOpen.Color=BGR(180,200,255)
tbOpen.Image(".\img\open.png")
tbOpen.onClick = @menu_Open

combo1.Create(panel1.Handle,68,4,152,300) ' Schriftart
combo1.onSelChange = @combo1_SelChange

combo2.Create(panel1.Handle,230,4,50,300)	' Schrift Size
combo2.onSelChange = @combo2_SelChange

line3.Create(panel1.Handle,"",290,2,3,28 )

tbBold.Create(panel1.Handle,300,2,30,30 )
tbBold.Color=BGR(180,200,255)
tbBold.Image(".\img\bold.png")
tbBold.onClick = @tbBold_Click

tbItalic.Create(panel1.Handle,326,2,30,30 )
tbItalic.Color=BGR(180,200,255)
tbItalic.Image(".\img\Italic.png")
tbItalic.onClick = @tbItalic_Click

tbUnder.Create(panel1.Handle,352,2,30,30 )
tbUnder.Color=BGR(180,200,255)
tbUnder.Image(".\img\unterl.png")
tbUnder.onClick = @tbUnder_Click

line1.Create(panel1.Handle,"",388,2,3,28 )

tbleft.Create(panel1.Handle,400,2,30,30 )
tbleft.Color=BGR(180,200,255)
tbleft.Image(".\img\links.png")
tbleft.onClick = @tbleft_Click

tbcenter.Create(panel1.Handle,426,2,30,30 )
tbcenter.Color=BGR(180,200,255)
tbcenter.Image(".\img\center.png")
tbcenter.onClick = @tbcenter_Click

tbright.Create(panel1.Handle,452,2,30,30 )
tbright.Color=BGR(180,200,255)
tbright.Image(".\img\rechts.png")
tbright.onClick = @tbright_Click

line2.Create(panel1.Handle,"",488,2,3,28 )

tbColor.Create(panel1.Handle,495,2,120,30 )
tbColor.TextPos = FALSE
tbColor.Caption = "TextFarbe"
tbColor.Image(".\img\TextCol.bmp")
tbColor.color = BGR(180,200,255)
tbColor.onClick = @tbColor_Click
'---------------------------------------------------------------------
' Initialisierungen Var, array usw. hier

addFontToCombo
addSizeToCombo

RichEditStart


'------ Show entlt MessageLoop - muss immer am Ende sein ------------
form1.Show
End