
'------------------------------------------------------------------------------------------
' Bitmap  Laden oder Puffer - DC im Speicher
'------------------------------------------------------------------------------------------
Type fBitmap Extends Object  	
  	Public:
	Declare Property bmWidth As Integer						' Get Bitmap Width
   Declare Property bmWidth( ByVal x As Integer )		' Set Bitmap Width
  	Declare Property bmHeight As Integer					' Get Bitmap Height
   Declare Property bmHeight( ByVal x As Integer )		' Set Bitmap Height
   Declare Property bmDC() As HDC							' Get HDC
   Declare Property bmColor As UInteger
   Declare Property bmColor( ByVal x As UInteger )   
  
   Declare Sub LoadBmp(res As String)
   Declare Sub memDC(ByVal buffW As Integer, ByVal buffH As Integer) 
   Declare Sub CopyRct(ByVal ZielDC As HDC, zielrect As RECT ,ByVal X As Integer, ByVal Y As Integer ) 
	Declare DESTRUCTOR  ( )
	Private:
   As Integer 	w 	 	= 0
  	As Integer 	h    	= 0
  	As HDC     	dc   	= 0
  	As UInteger bkC 	= &HFFFFFF
  
End Type

Property fBitmap.bmWidth() As Integer
  Return this.w
End Property
Property fBitmap.bmWidth( ByVal x As Integer )
  this.w = x
End Property
Property fBitmap.bmHeight() As Integer
  Return this.h
End Property
Property fBitmap.bmHeight( ByVal x As Integer )
  this.h = x
End Property
Property fBitmap.bmColor() As UInteger
	Return this.bkC
End Property
Property fBitmap.bmColor( ByVal x As UInteger )
	
	this.bkC = x			' x muss RGB Farbwert sein
	If this.dc <> 0 Then
  		Dim hBr As HBRUSH 		
  		hBr = CreateSolidBrush(x)
  		hBr = SelectObject(this.dc,hBr)
		DeleteObject(hBr)  		
	End If
	
End Property

Property fBitmap.bmDC() As HDC
  Return this.dc
End Property
DESTRUCTOR fBitmap ()
	If this.dc <> 0 Then
  		DeleteDC(this.dc)
	End If
END Destructor
' ----------------------------------------------- Bild laden ----------------------------
Sub fBitmap.LoadBmp(res As String)
	Dim hBmp 	As HBITMAP
	Dim hDC 		As HDC
	Dim szRes  	As ZString * 64
	Dim bm		As BITMAP
	
	If this.dc <> 0 Then
  		DeleteDC(this.dc)
  		this.dc = 0
	End If
	
   szRes		= res
   If InStr(szRes,".") = 0 Then  	' Wenn ein Punkt (.) enthalen ist, dann Deteiname 
		hBmp		= LoadBitmap(GetModuleHandle( NULL ), cast( LPCSTR, @szRes ))	
		If hBmp  = 0 Then
			MessageBox( null, "Fehler - fBitmap ist nicht geladen", "Error", MB_ICONERROR )
			Exit sub
		EndIf
   Else										' Ohne Punkt (.) Resource
   	hBmp		= LoadImage(NULL,@szRes,IMAGE_Bitmap,0,0,LR_DEFAULTCOLOR Or LR_LOADFROMFILE )
		If hBmp  = 0 Then
			MessageBox( null, "Fehler - fBitmap ist nicht geladen", "Error", MB_ICONERROR )
			Exit sub
		EndIf  	
   End If
   
   GetObject(hBmp,SizeOf(bm),@bm)
   this.w = bm.bmWidth
   this.h = bm.bmHeight
    
	hDC 		= GetDC(0)						' 0 ist Desktop
   this.dc	= CreateCompatibleDC(hDC)
	SelectObject(this.dc,hBmp)

	DeleteObject(hBmp)
	ReleaseDC(0,hDC)

End Sub

Sub fBitmap.CopyRct(ByVal ZielDC As HDC, zielrect As RECT ,ByVal X As Integer,ByVal Y As Integer ) 	
	If (ZielDC<>0) And (this.dc<>0) Then
		BitBlt(ZielDC,zielrect.left,zielrect.top,zielrect.right,zielrect.bottom,this.dc, X,Y,SRCCOPY)
	EndIf
End Sub
' ------------------------------------- nur Puffer erzeugen -----------------------------------
Sub fBitmap.memDC(ByVal buffW As Integer, ByVal buffH As Integer) 
	
	Dim hBmp 	As HBITMAP
	Dim hDC 		As HDC
	
	If this.dc <> 0 Then
  		DeleteDC(this.dc)
  		this.dc = 0
	End If
	
	this.w = buffW
   this.h = buffH
   
   hDC 		= GetDC(0)						' 0 ist Desktop
   this.dc	= CreateCompatibleDC(hDC)
   hBmp		= CreateCompatibleBitmap(hDC,buffW,buffH)
   SelectObject(this.dc,hBmp)
   
   DeleteObject(hBmp)
	ReleaseDC(0,hDC)
	
	If this.bkC <> 0 Then
		Dim hBr As HBRUSH
		Dim hPen As HPEN
  		Dim rc  As RECT
  		SetRect(@rc,0,0,this.w,this.h)
  		hBr = CreateSolidBrush(this.bkC)
  		FillRect(this.dc,@rc,hBr)
  		hBr = SelectObject(this.dc,hBr) 		  		
  		hPen = CreatePen(PS_SOLID,1,&H0) 		
  		hPen = SelectObject(this.dc,hPen)
		DeleteObject(hPen)  				
		DeleteObject(hBr)
	EndIf
	
End Sub

