'---------------------------------------------------------------------------------------------------------
'Static Controls - Bitmap 
'---------------------------------------------------------------------------------------------------------
Type FBmpLabel Extends Control
	
	public: 	
	Declare Property Border As Integer
   Declare Property Border(ByVal value As Integer)   
   Declare Sub Create(ByVal hParent As HWND, bmp As String,ByVal x As Integer,ByVal y As Integer)
   Declare Constructor
   Declare Destructor 
	Private: 
   As HBITMAP  b_BMP			= 0
   As Integer	b_Border		= 0
End Type
Constructor FBmpLabel
	this.Handle  = 0
  	this.ExStyle = WS_EX_STATICEDGE	
	this.Style 	 = WS_CHILD Or WS_VISIBLE  Or SS_BITMAP	
End Constructor
Destructor FBmpLabel
	If this.b_BMP Then
		DeleteObject(this.b_BMP)
	EndIf
	this.Handle = 0
End Destructor
Property FBmpLabel.Border As Integer
	Return this.b_Border
End Property
Property FBmpLabel.Border(ByVal value As Integer)
	If this.Handle Then
		Select Case value
			Case 0
				this.b_Border 	=  0
				this.Style  	=  WS_CHILD Or WS_VISIBLE  Or SS_BITMAP							' ohne
				this.ExStyle	= 0
			Case 1
				this.b_Border 	=  1
				this.Style  	=  WS_CHILD Or WS_VISIBLE  Or SS_BITMAP	Or WS_BORDER		' Rahmen
				this.ExStyle	= 0
			Case 2
				this.b_Border 	= 2
				this.Style  	= WS_CHILD Or WS_VISIBLE  Or SS_BITMAP Or SS_SUNKEN		 	' Sunken
				this.ExStyle 	= WS_EX_STATICEDGE 
		End Select
		SetWindowLong(this.handle,GWL_STYLE,this.style)
		SetWindowLong(this.handle,GWL_EXSTYLE,this.Exstyle)
		Repaint
	EndIf
End Property

Sub FBmpLabel.Create(ByVal hParent As HWND, fBmp As String,ByVal x As Integer,ByVal y As Integer)
	     
   
   Dim As FBILoad Ptr bml
   bml = New FBILoad
   
   If InStr(fBmp,".") = 0 Then  	' Resource 
		bml->LoadBitmapRes(fBmp)
   Else									' Deteiname
   	bml->LoadBitmapFile(fBmp)
   End If
   this.b_BMP 	= bml->CopyhBitmap
   this.Width 	= bml->bWidth
   this.Height = bml->bHeight 
   Delete bml
       
   this.Handle = CreateWindowEx( this.Exstyle , "STATIC" , "", this.style , x, y, this.Width, this.Height , _       '                  
                          hParent , NULL, GetModuleHandle(0) , NULL )
                          
                                             
   If this.Handle Then  	
   	SendMessage(this.Handle,STM_SETIMAGE,IMAGE_BITMAP,Cast(LPARAM,this.b_BMP))
   	this.Left	= x
		this.Top		= y
   	this.Parent  = hParent  
   Else
   	MessageBox( null, "Fehler - Bitmap ist nicht geladen", "Error", MB_ICONERROR )
   End If  
   
End Sub
