'--------------------------------------------------------------------
'									FDialogBox
'--------------------------------------------------------------------
Type FDialogBox Extends Object
	
	public: 
	Declare Property ExStyle() As UInteger					' Get  ExStyle
  	Declare Property ExStyle(ByVal value As UInteger)	' Set  ExStyle
	Declare Property Caption as string						' Get  Caption
   Declare Property Caption(value as string)				' Set  Caption
   Declare Property Color as UInteger
   Declare Property Color(value as UInteger)  
   Declare Property Handle() As HWND						' Get  Handle
   Declare Property Center(ByVal value As Integer) 
   Declare Function Create(ByVal hParent As HWND,sCaption As String,ByVal w As Integer,ByVal h As Integer ) As Integer
   Declare Sub Close(ByVal retVal As Integer)
   Declare Constructor
   Declare Destructor
   
   ' Events
   OnInitdialog As Sub(ByVal hWind As HWND) 
	onShow as Sub(ByVal flag As Integer)
	onSize As Sub(ByVal w As Integer, ByVal h As Integer,ByVal flag As Integer)
	onPaint As Sub(ByVal hDC As HDC)
	onLbuttondown As Sub(ByVal x As Integer,ByVal y As Integer,ByVal flag As Integer)
	onLbuttonup As Sub(ByVal x As Integer,ByVal y As Integer,ByVal flag As Integer)
	onMousemove As Sub(ByVal x As Integer,ByVal y As Integer,ByVal flag As Integer)
	onKeyDown As Sub(ByVal nVirtKey As Integer,ByVal lKeyDat As Integer)
	onKeyChar As Sub(ByVal nVirtKey As Integer,ByVal lKeyDat As Integer)
	onKeyUp As Sub(ByVal nVirtKey As Integer,ByVal lKeyDat As Integer)
	onCommand As Sub(ByVal notify As Integer,ByVal ID As Integer,ByVal ctl As LPARAM)
	onClose As Sub()
	
	Private: 
   Declare Static Function DlgWinProc(hCtrl As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   As Integer	d_Left		= 0
	As Integer  d_Top			= 0
   As Integer 	d_Width 	 	= 0
  	As Integer 	d_Height   	= 0
  	As HWND    	d_Handle   	= 0
  	As String 	d_Caption   = "Dialog"
	As UInteger	d_Style 		= 0
	As UInteger d_Exstyle	= 0
	As UInteger d_Color 		= &HFFFFFF
   As Integer  d_Center 	= 1
   As HWND		d_Parent		= 0

End Type
Property FDialogBox.ExStyle() As UInteger						' Get  ExStyle
	Return this.d_Exstyle
end Property
Property FDialogBox.ExStyle(ByVal value As UInteger)			' Set  ExStyle
	this.d_Exstyle = value
end Property
Property FDialogBox.Color as UInteger
	Return this.d_Color
End Property
Property FDialogBox.Color(value as UInteger)
	this.d_Color = value
End Property
Property FDialogBox.Handle() As HWND								' Get Handle
  Return this.d_Handle
End Property

Property FDialogBox.Caption as string								' Get Caption
   Return this.d_Caption
End Property

Property FDialogBox.Caption(value as string) 					' Set Caption
   If this.d_Handle Then				
   	this.d_Caption = value 
    	SetWindowText(d_Handle,value) 
    	ShowWindow( d_Handle, SW_HIDE)	' alle nderungen nach Create werden
	 	ShowWindow( d_Handle, SW_SHOW)	' hier neu gezeichnet
   End If 	
End Property

Property FDialogBox.Center(ByVal value As Integer) 
	d_Center = value
End Property

Function FDialogBox.DlgWinProc(hWnd As HWND, uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
      
   Dim  As FDialogBox Ptr Dialog = Cast(FDialogBox Ptr,GetWindowLong(hWnd,GWL_USERDATA)) 
   Dim hBr  As HBRUSH
   Dim As Integer lKeyDat = 0
       
   Select case uMsg   	
   	Case WM_INITDIALOG  
   		Dialog = Cast(FDialogBox Ptr,lParam)
   		SetWindowLong(hWnd,GWL_USERDATA,CInt(Dialog))
   		Dialog->d_Handle = hWnd
			SetWindowText(hWnd,Dialog->d_caption)
			MoveWindow(hWnd,Dialog->d_Left,Dialog->d_Top,Dialog->d_Width,Dialog->d_Height,TRUE)
   		If Dialog->OnInitdialog Then Dialog->OnInitdialog(hWnd)
   		Function = 0
   		Exit Function  		
   		'------------------------- onShow
   	Case WM_SHOWWINDOW
   		If Dialog Then 
            If Dialog->onShow then Dialog->onShow(wParam)
   		End If 
			Function = 0
   		Exit Function
   		'------------------------- onSize
   	Case WM_SIZE
   		If Dialog Then 
            If Dialog->onSize then Dialog->onSize(LOWORD(lParam),HIWORD(lParam),wParam)
   		End If 
   		Function = 0
   		Exit Function
   	
   		'------------------------- onPaint
   	Case WM_PAINT   		
    		dim pnt as PAINTSTRUCT
    		dim hDC as HDC
         hDC = BeginPaint( hWnd, @pnt )
         
	   		If Dialog Then
	            If Dialog->onPaint then Dialog->onPaint(hDC)
	   		End If   		
   		EndPaint( hWnd, @pnt )
   		Function = 0
   		Exit Function
   		'------------------------- Hintergrundfarbe dieser Dialog
   	Case WM_CTLCOLORDLG
   		If hBr Then
   			DeleteObject(hBr)
   		EndIf
   		hBr = CreateSolidBrush(Dialog->d_Color)
   		Return Cast(LRESULT, hBr)
   		'------------------------- Hintergrundfarbe Controls
   		
   	Case WM_LBUTTONDOWN
   		If Dialog Then
               If Dialog->onLbuttondown then Dialog->onLbuttondown(LOWORD(lParam),HIWORD(lParam),wParam)
   		End If 
   		Function = 0
   		Exit Function
   		'------------------------- 
   	Case WM_LBUTTONUP  
			If Dialog Then
            If Dialog->onLbuttonup then Dialog->onLbuttonup(LOWORD(lParam),HIWORD(lParam),wParam)
			End If 
			Function = 0
   		Exit Function
   		'------------------------- 
   	Case WM_MOUSEMOVE
   		If Dialog Then
            If Dialog->onMousemove then Dialog->onMousemove(LOWORD(lParam),HIWORD(lParam),wParam)
   		End If 
   		Function = 0
   		Exit Function
   		'------------------------- 
   	Case WM_KEYDOWN
   		If Dialog Then   			
   			If Dialog->onKeyDown then 
   				If GetKeyState(VK_SHIFT) < -126 Then
						lKeyDat = VK_SHIFT	'&H10
   				ElseIf GetKeyState(VK_CONTROL) < -126 Then	
						lKeyDat = VK_CONTROL	'&H11
   				ElseIf GetKeyState(VK_MENU) < -126 Then		
						lKeyDat = VK_MENU		'&H12
					End If	
   				Dialog->onKeyDown(wParam,lKeyDat)
   			EndIf
   		End If	
   		Function = 0	
         Exit Function
   		'------------------------- 
   	Case WM_CHAR
   		If Dialog Then
   			If Dialog->onKeyChar then 
   				If GetKeyState(VK_SHIFT) < -126 Then
						lKeyDat = VK_SHIFT	'&H10
   				ElseIf GetKeyState(VK_CONTROL) < -126 Then	
						lKeyDat = VK_CONTROL	'&H11
   				ElseIf GetKeyState(VK_MENU) < -126 Then		
						lKeyDat = VK_MENU		'&H12
					End If	
   				Dialog->onKeyChar(wParam,lKeyDat)
   			EndIf
   		End If	
   		Function = 0	
         Exit Function
         '------------------------- 
   	Case WM_KEYUP 
   		If Dialog Then
   			If Dialog->onKeyUp then 
   				If GetKeyState(VK_SHIFT) < -126 Then
						lKeyDat = VK_SHIFT	'&H10
   				ElseIf GetKeyState(VK_CONTROL) < -126 Then	
						lKeyDat = VK_CONTROL	'&H11
   				ElseIf GetKeyState(VK_MENU) < -126 Then		
						lKeyDat = VK_MENU		'&H12
					End If	
   				Dialog->onKeyUp(wParam,lKeyDat)
   			EndIf
   		End If	
   		Function = 0	
         Exit Function
   
   		'-------------------------  		
   	Case WM_COMMAND		
   		If Dialog Then
   			If Dialog->onCommand then Dialog->onCommand(HIWORD(wParam),LoWord(wParam), lParam)
   		End If	
   		Exit Function
   		'-------------------------
   	Case WM_SYSCOMMAND
   		If wParam = SC_CLOSE	Then
   		 EndDialog(hWnd,0)
   		End If
   		Function = 0	
         Exit Function
   	case WM_CLOSE
   		If Dialog then
               If Dialog->onClose then Dialog->onClose()
   		End If 
   		If hBr Then
   			DeleteObject(hBr)
   		EndIf
   		DestroyWindow(hWnd)
         Function = 0	
         Exit Function
   End Select
    
end Function
Function FDialogBox.Create(ByVal hParent As HWND, sCaption As String,ByVal w As Integer,ByVal h As Integer ) As Integer
 
   Dim As RECT rc 
   Dim as DLGTEMPLATE Ptr lpdt
   Dim As HGLOBAL hgbl 
   Dim As Integer iRet
   
   this.d_Parent	 = hParent
  
   If hParent Then
	   GetWindowRect(hParent,@rc)	
	   this.d_Left = ((rc.right + rc.left ) / 2) - (w / 2)
		this.d_Top  = ((rc.bottom + rc.top ) / 2) - (h / 2)
		
   Else
   	Dim As Integer SreenX = GetSystemMetrics(SM_CXSCREEN) 
		Dim As Integer SreenY = GetSystemMetrics(SM_CYSCREEN)
		this.d_Left = Abs((SreenX - w) / 2)
		this.d_Top  = Abs((SreenY - h) / 2)
   EndIf
	
	this.d_Width 	= w
	this.d_Height  = h	
	this.d_Caption = sCaption 
	
	hgbl =  GlobalAlloc(LMEM_ZEROINIT, 1024)
   if hgbl = 0 Then  return -1
   lpdt = GlobalLock(hgbl)

	 	
   lpdt->style = this.d_Style
   lpdt->dwExtendedStyle = this.d_Exstyle
   lpdt->cdit = 0 				'number of controls
   lpdt->x  = this.d_Left
   lpdt->y  = this.d_Top
   lpdt->cx = this.d_Width
   lpdt->cy = this.d_Height
   
   GlobalUnlock(hgbl)
  	iRet = DialogBoxIndirectParam(GetModuleHandle(0), lpdt , hParent , @FDialogBox.DlgWinProc, CInt(@This) ) 
	GlobalFree(hgbl)
	
	Function = iRet
End Function

Sub FDialogBox.Close(ByVal retVal As Integer)
	If d_Handle Then
		EndDialog(d_Handle,retVal)
	End If
End Sub
Constructor FDialogBox 	
  	d_Handle  = 0
  	d_Exstyle = WS_EX_CONTROLPARENT 	
	d_Style 	 = WS_DLGFRAME  OR WS_BORDER OR WS_SYSMENU OR  WS_CAPTION Or WS_VISIBLE Or DS_SETFONT
end Constructor

Destructor FDialogBox
    d_Handle  = 0
End Destructor
