
'--------------------------------------------------------------------
' 					Groupbox
'--------------------------------------------------------------------
Type FGroupbox Extends Control		
	public: 	
	Declare Property Border As Integer
	Declare Property Border(ByVal value As Integer)   
	Declare Property BorderColor As UInteger
	Declare Property BorderColor(ByVal value As UInteger) 
	  
   Declare Sub Create(ByVal hParent As HWND, Capt As String,ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Constructor
   Declare Destructor  
   Declare Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   Private:
   As Integer  b_Border = 1
   As UInteger b_BorderColor = &H909090
End Type
Constructor FGroupbox	
  	this.Handle  = 0
  	this.ExStyle = WS_EX_CONTROLPARENT 	
	this.Style 	 = WS_CHILD Or WS_VISIBLE 
End Constructor

Destructor FGroupbox
   this.Handle  = 0
End Destructor

Property FGroupbox.Border As Integer
	Return this.b_Border
End Property
Property FGroupbox.Border(ByVal value As Integer)  
	this.b_Border = value
End Property
Property FGroupbox.BorderColor As UInteger
	Return this.b_BorderColor
End Property
Property FGroupbox.BorderColor(ByVal value As UInteger)
	this.b_BorderColor = value
End Property
	
Function FGroupbox.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT

   Function = 0 
  
   Dim As HDC hDc
   Dim As RECT rc
   Dim As SIZEL ti
   Dim As HBRUSH hBr  
   Dim szTxt As ZString * 128
   
   szTxt = this.Caption
   
   Select case uMsg  
   	
   	Case WM_PAINT	
    		dim pnt as PAINTSTRUCT
         hDC = BeginPaint( hWnd, @pnt )
   		 DeleteObject(SelectObject(hDc,this.Font))
         GetClientRect(hWnd,@rc)
   	
			'Hintergrund  Color
      	SetBkColor(hDC,this.Color)
   		hBr = CreateSolidBrush(this.Color)
   		FillRect(hDC,@rc,hBr)
   		DeleteObject(hBr)    
	   	
	   	If Len(this.Caption) > 0 Then	
		   	If GetTextExtentPoint32(hDC,@szTxt,Len(szTxt),@ti) Then		
		   		rc.top = rc.top + Int(ti.cy/2)
		   	Else
		   		ti.cy = 14
		   		rc.top = rc.top + Int(ti.cy/2)
		   	EndIf
	   	End If	
	   		
   		'Rahmen ------------------------------
			If this.b_Border = 1 Then
      		DrawEdge(hDC,@rc, EDGE_ETCHED	 , BF_RECT )
			ElseIf this.b_Border = 2 Then
      		DrawEdge(hDC,@rc, EDGE_BUMP , BF_RECT )
			ElseIf this.b_Border = 3 Then
				hBr = CreateSolidBrush(this.b_BorderColor)
				FrameRect(hDC,@rc,hBr)
				DeleteObject(hBr)
			End If
			
			If Len(this.Caption) > 0 Then	
				'Text --------------------------------
				GetClientRect(hWnd,@rc)
				
	         rc.left = rc.left + 10
	         rc.right = rc.left + ti.cx + 3
	         rc.bottom = rc.Top + int(ti.cy)+5
	         rc.Top = rc.Top  - 4	
	         hBr = CreateSolidBrush(this.Color)
	   		FillRect(hDC,@rc,hBr)
	   		DeleteObject(hBr)    
	         
	         SetTextColor(hDC,this.TextColor)      	
	   		DrawText(hDC,@szTxt, -1, @rc, DT_SINGLELINE or DT_LEFT or DT_VCENTER)
			End If
   		EndPaint( hWnd, @pnt )
   		Function = 0
   		Exit Function
   	
   End Select
  
   Function = DefWindowProc(hWnd,uMsg,wParam,lParam)
end Function
'
Sub FGroupbox.Create(ByVal hParent As HWND, Capt As String,ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )

   Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst
 	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
         
   this.Handle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE Or WS_CHILD  , x, y, w , h , _                    
                          hParent , NULL, hInst , NULL )
                                                   
   SetWindowLong(this.Handle ,GWL_USERDATA,CInt(@This)) ' Zeiger diese Instanz                        
                                                                    
   If this.Handle  Then  		
   	this.Left	 = x
		this.Top		 = y
   	this.Width 	 = w
  		this.Height  = h
  		this.Caption = Capt 
   	this.Parent  = hParent  	
   Else
   	MessageBox(0,"Fehler - Create Group","Fehler",MB_ICONERROR)
   End If 
End Sub
