
'------------------------------------------------------------------------------
' 					Statusbar
'------------------------------------------------------------------------------
Type FStatusbar Extends Control	
	public: 	
	Declare Property SimplePanel(ByVal value As Integer)
	Declare Property SimplePanel  As Integer
	Declare Property SimpleText( value As String)
	Declare Property SimpleText As String
	Declare Sub setSize(ByVal w As short,ByVal h As Short)
	Declare Sub AddPanels(ByVal PartWidth As Integer)
	Declare Sub SetPanelText(ByVal Part As Integer, txt As String)
   Declare Sub Create(ByVal hParent As HWND )
   Declare Constructor
   Declare Destructor  
   
   Private:
   As Integer nPart(64)
   As String  b_SimpleText	= ""
   As Integer b_SimplePanel= FALSE
   As Integer b_Panels = 0
End Type
Constructor FStatusbar
	Dim As Integer i
	If InitCommon = 0 Then 
		InitCommonControls
		InitCommon = 1
	EndIf
	For i = 0 To 64
		nPart(i)= 0
	Next i
	this.b_Panels = 0
  	this.Handle  = 0
  	this.ExStyle = 0	
	this.Style 	 =  WS_CHILD Or WS_VISIBLE 
end Constructor

Destructor FStatusbar
	Erase nPart
   this.Handle  = 0
End Destructor

Property FStatusbar.SimplePanel(ByVal value As Integer)
	If this.Handle Then
		If value = FALSE then
			This.b_SimplePanel = FALSE
			SendMessage(this.Handle,SB_SIMPLE,FALSE,0)
		Else
			SendMessage(this.Handle,SB_SIMPLE,TRUE,0)
			This.b_SimplePanel = TRUE
		Endif	
	EndIf	
End Property
Property FStatusbar.SimplePanel  As Integer
	Return This.b_SimplePanel
End Property
Property FStatusbar.SimpleText( value As String)
	Dim As ZString * MAX_PATH szText
	If this.Handle Then
		szText = value
		SendMessage(this.Handle,SB_SETTEXT,255,CInt(@szText))
		this.b_SimpleText = value
	EndIf	
End Property
Property FStatusbar.SimpleText As String
	Return this.b_SimpleText
End Property
Sub FStatusbar.AddPanels(ByVal PartWidth As Integer)
	
   Dim As Integer i,lastWidth
	
	lastWidth = 0
	
	If this.b_Panels > 64 Then Exit Sub
		
	If this.Handle Then
		
		If this.b_Panels > 0 Then
			for i = 0 To this.b_Panels - 1	
				lastWidth = lastWidth + nPart(i)				
			Next i
		EndIf
		If PartWidth=-1 Then
			nPart(this.b_Panels) = -1	
		Else
			nPart(this.b_Panels) =	lastWidth + PartWidth
		EndIf
		
      i = this.b_Panels + 1
      
    	SendMessage(this.Handle, SB_SETPARTS, i ,CInt( @nPart(0)))
		this.b_Panels = this.b_Panels + 1
		
	EndIf	
			
End Sub
Sub FStatusbar.SetPanelText(ByVal Part As Integer, txt As String)
	Dim As ZString * MAX_PATH szText
	If this.Handle Then
		If (Part >=0) And (Part < 65) Then
			szText =  txt
			SendMessage(this.Handle,SB_SETTEXT,Part,CInt(@szText))
		End If
	EndIf	
End Sub
Sub FStatusbar.SetSize(ByVal w As short,ByVal h As Short)
	If this.Handle Then		
			SendMessage(this.Handle,WM_SIZE,SIZE_RESTORED,MAKELPARAM(w,h))		
	EndIf	
End Sub
Sub FStatusbar.Create(ByVal hParent As HWND)
	
   Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst
   hInst = GetModuleHandle(0)
   szClass = "msctls_statusbar32"
         
   this.Handle = CreateWindowEx( 0  , @szClass , "", WS_VISIBLE OR WS_CHILD  , 0, 0, 0 , 0 , _
                           hParent , NULL, hInst , NULL )                                               
   this.Parent = hParent
   
   If this.Handle = 0  Then
   	MessageBox(0,"Fehler - Create Statusbar","Fehler",MB_ICONERROR)
   	Exit Sub
   End If
	
	
End Sub
